/***************************************************************************/
/**            Ansprechen des MDD fuer M-OPT-1/A (MODULAR-4/486)          **/
/**                                                                       **/
/**  Installationshinweise:                                               **/
/**                                                                       **/
/**  Programmnummer  : 600h                                               **/
/**  Tasknummer      : beliebig                                           **/
/**  Interruptquelle : 0 (wird nicht verwendet, da NI-Task)               **/
/**  Datenbereich    : 0                                                  **/
/**  Flags           : 0980h (nicht aktivieren, Auto-Init aufrufen        **/
/**                                                                       **/
/**                                                                       **/
/**                                                                       **/
/**                     Fr Borland C++ (Version 3.1)                     **/
/**                                                                       **/
/**                             Version 1.A.                              **/
/**                                                                       **/
/**                   Erstellungsdatum : 10.04.97                         **/
/**                    letzte nderung : 23.05.00                         **/
/**                             Status : Test                             **/
/**                              Autor : HK                               **/
/**                                                                       **/
/**         (c) 1997/2000 SORCUS Computer GmbH Heidelberg                 **/
/**                                                                       **/
/***************************************************************************/



/* Keine Registervariablen!! */
#pragma option -r-

/* Header fr die Echtzeitbibliothek einbinden */
#include "ml8rtbib.h"
#include "mddcps.h"
#include "MEM.H"

/* --- Allgemeine Angaben --- */
#define PROGRAM_NUMBER                  0x600
#define VERSION                         '1'
#define REVISION                        'A'
#define SLOT                            4

/* --- Aufbau der Programm-Descriptor-Tabelle (PDT) --- */

struct pdt_type
   {
   ML8_PDT_HEAD pdt_head;            /* PDT-Header */
   void* PFAR main_proc;             /* Pointer auf Hauptprozedur */
   void* PFAR auto_init;             /* Pointer auf Auto-Init-Prozedur */
   void* PFAR channel_init;          /* Pointer auf User-Prozedur */
   } pdt;



/* --- Aufbau des Parameterbereichs --- */

struct parameter_type
   {
   tdt_type tdt;
   HMDD8 handle_1;         /* Handle fr Byte-Zugriff */
   HMDD8 handle_2;         /* Handle fr Bit-Zugriff (Bit 0) */
   HMDD8 handle_3;         /* Handle fr Bit-Zugriff (Bit 2) */
   HMDD8 handle_4;         /* Handle fr Word-Zugriff */
   } par;


/****************************************************************************
/*
/*      Module:         M-OPT-1A
/*      Hardware ID:    0600h
/*      MDD-Task:       ML8D0600.LIB
/*
/****************************************************************************


/* --- Variable fuer Kanalparameterstruktur --- */

CPS_MOPT1A dig_in,r;


/* --- Funktionsprototypen --- */
void init_pdt (void);
void main_proc (void);
void auto_init (void);
void channel_init (void);


/* --- main_proc --- */

void main_proc (void)
{
 ml8rt_entry();
 ml8rt_exit();
}

/* Fehlerbehandlung */

void far pascal error_handler(void)
{

 ML8RT_ERROR_INFO_TYPE ep;
 ml8rt_get_error_info(&ep);
 ml8rt_reset_error();

}

/* --- auto_init --- */

void auto_init (void)
{
 ml8rt_entry();
 ml8rt_set_error_handler(&error_handler);
 ml8rt_exit();
}


/* --- channel_init --- */

void channel_init (void)
{
   UCHAR kbyte;      /* Variable fr Bits und Bytes */
   USHORT kword;     /* Variable fr 16-Bit */

   ml8rt_entry();

   /* Struktur fr das Lesen von 8 DINs */

   dig_in.usDevice         = DEVICE_DIN;
   dig_in.usFlags          = 0;
   dig_in.usIndexFirst     = 0;
   dig_in.usIndexLast      = 7;
   dig_in.usReadMode       = IO_MODE_DIRECT;
   par.handle_1 = mdd8_open_channel(SLOT, sizeof(dig_in), &dig_in);

   /* Struktur fr das Lesen von einem DIN */

   dig_in.usDevice         = DEVICE_DIN;
   dig_in.usFlags          = 0;
   dig_in.usIndexFirst     = 0;
   dig_in.usIndexLast      = 0;
   dig_in.usReadMode       = IO_MODE_DIRECT;
   par.handle_2 = mdd8_open_channel(SLOT, sizeof(dig_in), &dig_in);

   /* Struktur fr das Lesen von einem DIN */

   dig_in.usDevice         = DEVICE_DIN;
   dig_in.usFlags          = 0;
   dig_in.usIndexFirst     = 2;
   dig_in.usIndexLast      = 2;
   dig_in.usReadMode       = IO_MODE_DIRECT;
   par.handle_3 = mdd8_open_channel(SLOT, sizeof(dig_in), &dig_in);

   /* Struktur fr das Lesen von 16 DIN */

   dig_in.usDevice         = DEVICE_DIN;
   dig_in.usFlags          = 0;
   dig_in.usIndexFirst     = 0;
   dig_in.usIndexLast      = 15;
   dig_in.usReadMode       = IO_MODE_DIRECT;
   par.handle_4 = mdd8_open_channel(SLOT, sizeof(dig_in), &dig_in);

   /* Lesen aller 16 DIN */

   kword = mdd8_read_channel_word(par.handle_4);

   /* Lesen von 8 DIN */

   kbyte = mdd8_read_channel_byte(par.handle_1);

   /* Lesen von 1 DIN */

   kbyte = mdd8_read_channel_byte(par.handle_2);

   /* Lesen von 1 DIN */

   kbyte = mdd8_read_channel_byte(par.handle_3);

   /* Kanle, wenn sie nicht mehr gebraucht werden, wieder schlieen */

   mdd8_close_channel(&par.handle_1);
   mdd8_close_channel(&par.handle_2);
   mdd8_close_channel(&par.handle_3);
   mdd8_close_channel(&par.handle_4);
   ml8rt_exit();

   /* wegen Compiler-Warnung */

   kbyte = kbyte;
   kword = kword;
}


/* --- PDT initialisieren --- */

/* --- PREPARE --- */

void main (void)
{

   pdt.pdt_head.ucType              = 1;
   pdt.pdt_head.ucSize              = sizeof(ML8_PDT_HEAD);
   pdt.pdt_head.usGlobalProc        = 3;
   pdt.pdt_head.usProgNo            = PROGRAM_NUMBER;
   pdt.pdt_head.cVersion            = VERSION;
   pdt.pdt_head.cRevision           = REVISION;
   pdt.pdt_head.ucCPU               = _486DX;
   pdt.pdt_head.ucCoProc            = _NOCOPROZ;
   pdt.pdt_head.ucLanguage          = _CPP31;
   pdt.pdt_head.ucProgType          = _USER_PRG;
   pdt.pdt_head.usFlags             = _NI_TASK + _PDT_INFO_ENABLE + _LOCAL_DATA
                                      + _LOCAL_PARAMETER + _FIXED_DATASIZE;
   pdt.pdt_head.usInt               = 0;
   pdt.pdt_head.ulDataAdr           = 0L;
   pdt.pdt_head.ulDataSize          = 0L;
   pdt.pdt_head.ulDataSizeMin       = 0L;
   pdt.pdt_head.ulDataSizeMax       = 0L;
   ml8rt_phys_adr (&par, &pdt.pdt_head.ulGlobalParAdr);
   pdt.pdt_head.ulGlobalParAdr      = pdt.pdt_head.ulGlobalParAdr + sizeof(tdt_type);
   pdt.pdt_head.usGlobalParSize     = sizeof(par) - sizeof(tdt_type);
   pdt.pdt_head.ulHyperAdr           = 0L;
   pdt.main_proc                    = main_proc;
   pdt.auto_init                    = auto_init;
   pdt.channel_init                 = channel_init;
   ml8rt_set_pdt_adr (&pdt);
}
