/***************************************************************************/
/**            Ansprechen des MDD fuer M-OPT-1/B (MODULAR-4/486)          **/
/**                                                                       **/
/**  Installationshinweise:                                               **/
/**                                                                       **/
/**  Programmnummer  : 700h                                               **/
/**  Tasknummer      : beliebig                                           **/
/**  Interruptquelle : 0 (wird nicht verwendet, da NI-Task)               **/
/**  Datenbereich    : 0                                                  **/
/**  Flags           : 0980h (nicht aktivieren, Auto-Init aufrufen        **/
/**                                                                       **/
/**                                                                       **/
/**                                                                       **/
/**                     Fr Borland C++ (Version 3.1)                     **/
/**                                                                       **/
/**                             Version 1.A.                              **/
/**                                                                       **/
/**                   Erstellungsdatum : 23.04.97                         **/
/**                    letzte nderung : 23.05.00                         **/
/**                             Status : Test                             **/
/**                              Autor : HK                               **/
/**                                                                       **/
/**         (c) 1997/2000 SORCUS Computer GmbH Heidelberg                 **/
/**                                                                       **/
/***************************************************************************/



/* Keine Registervariablen!! */
#pragma option -r-

/* Header fr die Echtzeitbibliothek einbinden */
#include "ml8rtbib.h"
#include "mddcps.h"
#include "MEM.H"

/* --- Allgemeine Angaben --- */
#define PROGRAM_NUMBER                  0x700
#define VERSION                         '1'
#define REVISION                        'A'
#define SLOT                            4

/* --- Aufbau der Programm-Descriptor-Tabelle (PDT) --- */

struct pdt_type
   {
   ML8_PDT_HEAD pdt_head;                        /* Typ der PDT */
   void* PFAR main_proc;                         /* Pointer auf Hauptprozedur */
   void* PFAR auto_init;                         /* Pointer auf Auto-Init-Prozedur */
   void* PFAR channel_init;                      /* Pointer auf User-Prozedur */
   } pdt;



/* --- Aufbau des Parameterbereichs --- */

struct parameter_type
   {
   tdt_type tdt;
   HMDD8 handle_1;         /* Handle fr 8-Bit Zugriff auf MDD */
   HMDD8 handle_2;         /* Handle fr Bit Zugriff auf MDD */
   HMDD8 handle_3;         /* Handle fr Bit Zugriff auf MDD */
   HMDD8 handle_4;         /* Handle fr 16-Bit Zugriff auf MDD */
   HMDD8 handle_5;         /* Handle fr Zugriff auf Steuerkanal des MDD */
   HMDD8 handle_trig;      /* Handle fr Triggerkanal */
} par;


/****************************************************************************
/*
/*      Module:         M-OPT-1B
/*      Hardware ID:    0700h
/*      MDD-Task:       ML8D0700.LIB
/*
/****************************************************************************

/* --- Variable fuer Kanalparameterstruktur --- */

CPS_MOPT1B dig_out;


/* --- Funktionsprototypen --- */
void init_pdt (void);
void main_proc (void);
void auto_init (void);
void channel_init (void);


/* --- main_proc --- */

void main_proc (void)
{
 ml8rt_entry();
 ml8rt_exit();
}

/* Fehlerbehandlung */

void far pascal error_handler(void)
{
 ML8RT_ERROR_INFO_TYPE ep;
 ml8rt_get_error_info(&ep);
 ml8rt_reset_error();
}

/* --- auto_init --- */

void auto_init (void)
{
   ml8rt_entry();
   ml8rt_set_error_handler(*error_handler);
   ml8rt_exit();
}


/* --- channel_init --- */

void channel_init (void)
{
   USHORT kword;
   UCHAR kbyte;

   ml8rt_entry();

   /* Struktur fr Triggerkanal */

   dig_out.usDevice         = DEVICE_TRIG;
   dig_out.usFlags          = 0;
   dig_out.usIndexFirst     = 0;
   dig_out.usIndexLast      = 0;
   par.handle_trig = mdd8_open_channel(SLOT, sizeof(dig_out), &dig_out);

   /* Struktur fr Zugriff auf 8 DOUT */

   dig_out.usDevice         = DEVICE_DOUT;
   dig_out.usFlags          = 0;
   dig_out.usIndexFirst     = 0;
   dig_out.usIndexLast      = 7;
   dig_out.usReadMode       = IO_MODE_RAM;
   dig_out.usWriteMode      = IO_MODE_DIRECT;
   par.handle_1 = mdd8_open_channel(SLOT, sizeof(dig_out), &dig_out);

   /* Struktur fr Zugriff auf 1 DOUT */

   dig_out.usDevice         = DEVICE_DOUT;
   dig_out.usFlags          = 0;
   dig_out.usIndexFirst     = 0;
   dig_out.usIndexLast      = 0;
   dig_out.usReadMode       = IO_MODE_RAM;
   dig_out.usWriteMode      = IO_MODE_DIRECT;
   par.handle_2 = mdd8_open_channel(SLOT, sizeof(dig_out), &dig_out);

   /* Struktur fr Zugriff auf 1 DOUT */

   dig_out.usDevice         = DEVICE_DOUT;
   dig_out.usFlags          = 0;
   dig_out.usIndexFirst     = 2;
   dig_out.usIndexLast      = 2;
   dig_out.usReadMode       = IO_MODE_RAM;
   dig_out.usWriteMode      = IO_MODE_DIRECT;
   par.handle_3 = mdd8_open_channel(SLOT, sizeof(dig_out), &dig_out);

   /* Struktur fr Zugriff auf 16 DOUT */

   dig_out.usDevice         = DEVICE_DOUT;
   dig_out.usFlags          = 0;
   dig_out.usIndexFirst     = 0;
   dig_out.usIndexLast      = 15;
   dig_out.usWriteMode      = IO_MODE_DIRECT;
   dig_out.usReadMode       = IO_MODE_RAM;
   par.handle_4 = mdd8_open_channel(SLOT, sizeof(dig_out), &dig_out);

   /* Trigger auslsen */

   mdd8_trigger_channel(par.handle_trig);

   /* Struktur fr Zugriff auf Steuerkanal */

   dig_out.usDevice         = DEVICE_CTRL;
   dig_out.usFlags          = 0;
   dig_out.usIndexFirst     = 0;
   dig_out.usIndexLast      = 0;
   dig_out.usReadMode       = IO_MODE_DIRECT;
   par.handle_5 = mdd8_open_channel(SLOT, sizeof(dig_out), &dig_out);

   /* Steuerkanal auslesen */

   kbyte = mdd8_read_channel_byte(par.handle_5);

   /* Alle DOUT aktivieren */

   mdd8_write_channel_byte(par.handle_5,1);

   /* Steuerkanal auslesen */

   kbyte = mdd8_read_channel_byte(par.handle_5);

   /* Alle DOUT deaktivieren */

   mdd8_write_channel_byte(par.handle_5,0);

   /* Steuerkanal auslesen */

   kbyte = mdd8_read_channel_byte(par.handle_5);

   /* Zustand der 1. acht DOUT lesen */

   kbyte = mdd8_read_channel_byte(par.handle_1);

   /* Zustand der 1. acht DOUT verndern */

   mdd8_write_channel_byte(par.handle_1,1);
   mdd8_write_channel_byte(par.handle_1,0x45);

   /* Zustand von DOUT 0 verndern */

   mdd8_write_channel_byte(par.handle_2,1);

   /* Zustand von DOUT 0 und DOUT 2 zurcklesen */

   kbyte = mdd8_read_channel_byte(par.handle_2);

   kbyte = mdd8_read_channel_byte(par.handle_3);

   /* Zustand von DOUT 2 verndern */

   mdd8_write_channel_byte(par.handle_3,1);

   /* Zustand von DOUT 8 bis 15 verndern */

   mdd8_write_channel_word(par.handle_4,0x1133);

   /* Kanle, wenn sie nicht mehr gebraucht werden, schlieen */

   mdd8_close_channel(&par.handle_1);
   mdd8_close_channel(&par.handle_2);
   mdd8_close_channel(&par.handle_3);
   mdd8_close_channel(&par.handle_4);
   mdd8_close_channel(&par.handle_4);
   mdd8_close_channel(&par.handle_trig);
   ml8rt_exit();

   /* wegen Compiler-Warnung */
   kbyte = kbyte;
   kword = kword;
}


/* --- PDT initialisieren --- */

/* --- PREPARE --- */

void main (void)
   {

   pdt.pdt_head.ucType               = 1;
   pdt.pdt_head.ucSize               = sizeof(ML8_PDT_HEAD);
   pdt.pdt_head.usGlobalProc         = 3;
   pdt.pdt_head.usProgNo             = PROGRAM_NUMBER;
   pdt.pdt_head.cVersion             = VERSION;
   pdt.pdt_head.cRevision            = REVISION;
   pdt.pdt_head.ucCPU                = _486DX;
   pdt.pdt_head.ucCoProc             = _NOCOPROZ;
   pdt.pdt_head.ucLanguage           = _CPP31;
   pdt.pdt_head.ucProgType           = _USER_PRG;
   pdt.pdt_head.usFlags              = _NI_TASK + _PDT_INFO_ENABLE + _LOCAL_DATA
                                       + _LOCAL_PARAMETER + _FIXED_DATASIZE;
   pdt.pdt_head.usInt                = 0;
   pdt.pdt_head.ulDataAdr            = 0L;
   pdt.pdt_head.ulDataSize           = 0L;
   pdt.pdt_head.ulDataSizeMin        = 0L;
   pdt.pdt_head.ulDataSizeMax        = 0L;
   ml8rt_phys_adr (&par, &pdt.pdt_head.ulGlobalParAdr);
   pdt.pdt_head.ulGlobalParAdr       = pdt.pdt_head.ulGlobalParAdr + sizeof(tdt_type);
   pdt.pdt_head.usGlobalParSize      = sizeof(par) - sizeof(tdt_type);
   pdt.pdt_head.ulHyperAdr           = 0L;
   pdt.main_proc                     = main_proc;
   pdt.auto_init                     = auto_init;
   pdt.channel_init                  = channel_init;
   ml8rt_set_pdt_adr (&pdt);
}
