/***************************************************************************/
/**   Beispiel fr das Ansprechen des MDD fuer M-RU8-2  (MODULAR-4/486)   **/
/**                                                                       **/
/**  Installationshinweise:                                               **/
/**                                                                       **/
/**  Programmnummer  : 0d00h                                               **/
/**  Tasknummer      : beliebig                                           **/
/**  Interruptquelle : 0 (wird nicht verwendet, da NI-Task)               **/
/**  Datenbereich    : 0                                                  **/
/**  Flags           : 0980h (nicht aktivieren, Auto-Init aufrufen        **/
/**                                                                       **/
/**                                                                       **/
/**                                                                       **/
/**                     Fr Borland C++ (Version 3.1)                     **/
/**                                                                       **/
/**                             Version 1.B.                              **/
/**                                                                       **/
/**                   Erstellungsdatum : 25.04.97                         **/
/**                    letzte nderung : 05.06.2000                       **/
/**                             Status : Test                             **/
/**                              Autor : HK                               **/
/**                                                                       **/
/**            (c) 1997 SORCUS Computer GmbH Heidelberg                   **/
/**                                                                       **/
/***************************************************************************/



/* Keine Registervariablen!! */
#pragma option -r-

/* Header fr die Echtzeitbibliothek einbinden */
#include <ML8RTBIB.h>

/* --- Allgemeine Angaben --- */
#define PROGRAM_NUMBER                  0xD00
#define VERSION                         '1'
#define REVISION                        'B'
#define SLOT                            4

/* --- Aufbau der Programm-Descriptor-Tabelle (PDT) --- */

struct pdt_type
{
 ML8_PDT_HEAD pdt_head;       /* PDT-Header */
 void* PFAR main_proc;        /* Pointer auf Hauptprozedur */
 void* PFAR auto_init;        /* Pointer auf Auto-Init-Prozedur */
 void* PFAR channel_init;     /* Pointer auf Anwender-Prozedur */
} pdt;



/* --- Aufbau des Parameterbereichs --- */

struct parameter_type
   {
   TDT_TYPE tdt;
   HMDD8 handle_2;
   HMDD8 handle_3;
   HMDD8 handle_trig;
   } par;


/****************************************************************************
/*
/*      Module:         M-RU8-2
/*      Hardware ID:    0D00h
/*      MDD-Task:       ML8D0D00.LIB
/*
/****************************************************************************


/* --- Variable fuer Kanalparameterstruktur --- */

CPS_MRU82 dig_out,r;


/* --- Funktionsprototypen --- */
void init_pdt (void);
void main_proc (void);
void auto_init (void);
void channel_init (void);


/* --- main_proc --- */

void main_proc (void)
{
 ml8rt_entry();
 ml8rt_exit();
}


/* --- auto_init --- */
/* liest Informationen ueber installierte MDDs */

void far pascal error_handler(void)
{
 ML8RT_ERROR_INFO_TYPE *wError;
 ml8rt_get_error_info(wError);
 ml8rt_reset_error();
}

void auto_init (void)
{
 ml8rt_entry();
 ml8rt_set_error_handler(error_handler);
 ml8rt_exit();
}

/* --- channel_init --- */

void channel_init (void)
   {
   USHORT q,i,k,n;
   UCHAR kbyte;
   ULONG l;

   ml8rt_entry();

   /* CPS-Struktur fr das Setzen von DOUT-0 bis DOUT-7 initialisieren */

   dig_out.usDevice         = DEVICE_DOUT;
   dig_out.usFlags          = 0;
   dig_out.usIndexFirst     = 0;
   dig_out.usIndexLast      = 7;
   dig_out.usWriteMode      = IO_MODE_DIRECT;
   dig_out.usReadMode       = IO_MODE_RAM;
   par.handle_3 = mdd8_open_channel(SLOT, sizeof(dig_out), &dig_out);

   mdd8_write_channel_byte(par.handle_3,0);

   /* CPS-Struktur fr das Triggern des Watchdog initialisieren */

   dig_out.usDevice         = DEVICE_TRIG;
   dig_out.usFlags          = 0;
   dig_out.usIndexFirst     = 0;
   dig_out.usIndexLast      = 0;
   par.handle_trig = mdd8_open_channel(SLOT, sizeof(dig_out), &dig_out);

   /* CPS-Struktur fr das Setzen eines Bits (DOUT-3) initialisieren */

   dig_out.usDevice         = DEVICE_DOUT;
   dig_out.usFlags          = 0;
   dig_out.usIndexFirst     = 3;
   dig_out.usIndexLast      = 3;
   dig_out.usReadMode       = IO_MODE_RAM;
   dig_out.usWriteMode      = IO_MODE_DIRECT;
   par.handle_2 = mdd8_open_channel(4, sizeof(dig_out), &dig_out);

   kbyte = mdd8_read_channel_byte(par.handle_3);
   mdd8_write_channel_byte(par.handle_2,kbyte);
   kbyte = mdd8_read_channel_byte(par.handle_3);
   mdd8_write_channel_byte(par.handle_2,1);
   kbyte = mdd8_read_channel_byte(par.handle_3);
   mdd8_write_channel_byte(par.handle_2,0);
   kbyte = mdd8_read_channel_byte(par.handle_3);

   ml8rt_exit();
}


/* --- PDT initialisieren --- */

/* --- PREPARE --- */

void main (void)
{
   pdt.pdt_head.ucType              = 1;
   pdt.pdt_head.ucSize            = sizeof(ML8_PDT_HEAD);
   pdt.pdt_head.usGlobalProc = 3;
   pdt.pdt_head.usProgNo = PROGRAM_NUMBER;
   pdt.pdt_head.cVersion          = VERSION;
   pdt.pdt_head.cRevision         = REVISION;
   pdt.pdt_head.ucCPU         = _486DX;
   pdt.pdt_head.ucCoProc = _NOCOPROZ;
   pdt.pdt_head.ucLanguage         = _CPP31;
   pdt.pdt_head.ucProgType         = _USER_PRG;
   pdt.pdt_head.usFlags            = _NI_TASK + _PDT_INFO_ENABLE + _LOCAL_DATA
                          + _LOCAL_PARAMETER + _FIXED_DATASIZE;
   pdt.pdt_head.usInt = 0;
   pdt.pdt_head.ulDataAdr         = 0L;
   pdt.pdt_head.ulDataSize        = 0L;
   pdt.pdt_head.ulDataSizeMin         = 0L;
   pdt.pdt_head.ulDataSizeMax         = 0L;
   ml8rt_phys_adr (&par, &pdt.pdt_head.ulGlobalParAdr);
   pdt.pdt_head.ulGlobalParAdr    = pdt.pdt_head.ulGlobalParAdr + sizeof(TDT_TYPE);
   pdt.pdt_head.usGlobalParSize   = sizeof(par) - sizeof(TDT_TYPE);
   pdt.pdt_head.ulHyperAdr        = 0L;
   pdt.main_proc    = main_proc;
   pdt.auto_init    = auto_init;
   pdt.channel_init = channel_init;
   ml8rt_set_pdt_adr (&pdt);
}


