/***************************************************************************/
/**            Ansprechen des MDD fuer M-SH12-8 (MODULAR-4/486)           **/
/**                                                                       **/
/**  Installationshinweise:                                               **/
/**                                                                       **/
/**  Programmnummer  : 1800h                                              **/
/**  Tasknummer      : beliebig                                           **/
/**  Interruptquelle : 0 (wird nicht verwendet, da NI-Task)               **/
/**  Datenbereich    : 0                                                  **/
/**  Flags           : 0980h (nicht aktivieren, Auto-Init aufrufen        **/
/**                                                                       **/
/**                                                                       **/
/**                                                                       **/
/**                     Fr Borland C++ (Version 3.1)                     **/
/**                                                                       **/
/**                             Version 1.A.                              **/
/**                                                                       **/
/**                   Erstellungsdatum : 15.05.97                         **/
/**                    letzte nderung : 23.05.00                         **/
/**                             Status : Test                             **/
/**                              Autor : HK                               **/
/**                                                                       **/
/**         (c) 1997/2000 SORCUS Computer GmbH Heidelberg                 **/
/**                                                                       **/
/***************************************************************************/



/* Keine Registervariablen!! */
#pragma option -r-

/* Header fr die Echtzeitbibliothek einbinden */
#include "ml8rtbib.h"
#include "mddcps.h"
#include "MEM.H"
#include "DOS.H"

/* --- Allgemeine Angaben --- */
#define PROGRAM_NUMBER                  0x1800
#define VERSION                         '1'
#define REVISION                        'A'
#define SLOT                            4

/* --- Aufbau der Programm-Descriptor-Tabelle (PDT) --- */

struct pdt_type
   {
   ML8_PDT_HEAD pdt_head;          /* PDT-Header  */
   void* PFAR main_proc;           /* Pointer auf Haupt-Prozedur */
   void* PFAR auto_init;           /* Pointer auf Auto-Init-Prozedur */
   void* PFAR channel_init;        /* Pointer auf User-Prozedur */
   } pdt;



/* --- Aufbau des Parameterbereichs --- */

struct parameter_type
   {
   tdt_type tdt;
   HMDD8 handle_1;                   /* Handle fr 1 Kanal Zugriff AIN */
   HMDD8 handle_2;                   /* Handle fr 1 Kanal Zugriff AIN */
   HMDD8 handle_3;                   /* Handle fr 8 Kanal Zugriff AIN */
   HMDD8 handle_4;                   /* Handle fr 1 Kanal AOUT Zugriff */
   HMDD8 handle_ctrl;                /* Handle fr Steuer-Kanal Zugriff */
   HMDD8 handle_trig;                /* Handle fr Trigger-Kanal Zugriff */
   } par;


/****************************************************************************
/*
/*      Module:         M-SH12-8
/*      Hardware ID:    1800h
/*      MDD-Task:       ML8D1800.LIB
/*
/****************************************************************************

/* --- Variable fuer Kanalparameterstruktur --- */

CPS_MSH128 analog_in_out;


/* --- Funktionsprototypen --- */
void init_pdt (void);
void main_proc (void);
void auto_init (void);
void channel_init (void);


/* --- main_proc --- */

void main_proc (void)
   {
   ml8rt_entry();
   ml8rt_exit();
   };

/* Fehlerbehandlung */

void far pascal error_handler(void)
{
  ML8RT_ERROR_INFO_TYPE ep;
  ml8rt_get_error_info(&ep);
  ml8rt_reset_error();
}

/* --- auto_init --- */

void auto_init (void)
{
 ml8rt_entry();
 ml8rt_set_error_handler(*error_handler);
 ml8rt_exit();
}

/* --- channel_init --- */

void channel_init (void)
{
   SHORT kshort, ad_arr[8];
   USHORT err;

   ml8rt_entry();

   /* Struktur fr Steuerkanal (Initialisierung) */

   analog_in_out.usDevice         = DEVICE_CTRL;
   analog_in_out.usFlags          = 0;
   analog_in_out.usIndexFirst     = 0;
   analog_in_out.usIndexLast      = 0;
   analog_in_out.usReadMode       = IO_MODE_DIRECT;
   analog_in_out.usWriteMode      = IO_MODE_DIRECT;
   par.handle_ctrl = mdd8_open_channel(SLOT, sizeof(analog_in_out), &analog_in_out);

   /* Initialisierung des Moduls */

   mdd8_write_channel_byte(par.handle_ctrl,1);

   /* Struktur fr Zugriff auf 1 AIN */

   analog_in_out.usDevice         = DEVICE_AIN_SE;
   analog_in_out.usFlags          = 0;
   analog_in_out.usIndexFirst     = 0;
   analog_in_out.usIndexLast      = 0;
   analog_in_out.usReadMode       = IO_MODE_DIRECT;
   par.handle_1 = mdd8_open_channel(SLOT, sizeof(analog_in_out), &analog_in_out);

   /* Struktur fr Triggerkanal */

   analog_in_out.usDevice         = DEVICE_TRIG;
   analog_in_out.usFlags          = 0;
   analog_in_out.usIndexFirst     = 0;
   analog_in_out.usIndexLast      = 0;
   analog_in_out.usReadMode       = IO_MODE_DIRECT;
   par.handle_trig = mdd8_open_channel(SLOT, sizeof(analog_in_out), &analog_in_out);

   /* Trigger auslsen */

   mdd8_trigger_channel(par.handle_trig);

   /* A/D-Wert einlesen */

   kshort= mdd8_read_channel_short(par.handle_1);

   /* Struktur fr Zugriff auf 1 Kanal */

   analog_in_out.usDevice         = DEVICE_AIN_SE;
   analog_in_out.usIndexFirst     = 3;
   analog_in_out.usIndexLast      = 3;
   analog_in_out.usReadMode       = IO_MODE_DIRECT;
   par.handle_2 = mdd8_open_channel(SLOT, sizeof(analog_in_out), &analog_in_out);

   /* A/D-Wert einlesen */

   kshort = mdd8_read_channel_short(par.handle_2);

   /* Struktur fr Zugriff auf 1 Kanal */

   analog_in_out.usDevice         = DEVICE_AIN_SE;
   analog_in_out.usIndexFirst     = 7;
   analog_in_out.usIndexLast      = 7;
   analog_in_out.usReadMode       = IO_MODE_DIRECT;
   par.handle_2 = mdd8_open_channel(SLOT, sizeof(analog_in_out), &analog_in_out);

   /* A/D-Wert einlesen */

   kshort = mdd8_read_channel_short(par.handle_2);

   /* Struktur fr 8 AIN */

   analog_in_out.usIndexFirst     = 0;
   analog_in_out.usIndexLast      = 7;
   analog_in_out.usReadMode       = IO_MODE_DIRECT;
   par.handle_3 = mdd8_open_channel(SLOT, sizeof(analog_in_out), &analog_in_out);

   /* A/D-Kanle lesen */

   err = mdd8_read_channel_block(par.handle_3,8,&ad_arr);

   /* Struktur fr 1 AOUT */

   analog_in_out.usDevice         = DEVICE_AOUT;
   analog_in_out.usFlags          = _CP_EXCLUSIVE;
   analog_in_out.usIndexFirst     = 0;
   analog_in_out.usIndexLast      = 0;
   analog_in_out.usReadMode       = IO_MODE_RAM;
   analog_in_out.usWriteMode      = IO_MODE_DIRECT;
   par.handle_4 = mdd8_open_channel(SLOT, sizeof(analog_in_out), &analog_in_out);

   /* D/A-Wert schreiben */

   mdd8_write_channel_short(par.handle_4,1);

   /* D/A-Wert zurcklesen */

   kshort= mdd8_read_channel_short(par.handle_4);

   /* D/A-Wert schreiben */

   mdd8_write_channel_short(par.handle_4,2048);

   /* D/A-Wert zurcklesen */

   kshort= mdd8_read_channel_short(par.handle_4);


   /* Struktur fr Steuerkanal (Betriebsart) */

   analog_in_out.usDevice         = DEVICE_CTRL;
   analog_in_out.usFlags          = 0;
   analog_in_out.usIndexFirst     = 1;
   analog_in_out.usIndexLast      = 1;
   analog_in_out.usReadMode       = IO_MODE_DIRECT;
   par.handle_ctrl = mdd8_open_channel(SLOT, sizeof(analog_in_out), &analog_in_out);

   /* Betriebsart anwhlen */

   mdd8_write_channel_byte(par.handle_ctrl,1);

   /* Struktur fr Steuerkanal (Interrupt) */

   analog_in_out.usDevice         = DEVICE_CTRL;
   analog_in_out.usFlags          = 0;
   analog_in_out.usIndexFirst     = 2;
   analog_in_out.usIndexLast      = 2;
   analog_in_out.usReadMode       = IO_MODE_DIRECT;
   par.handle_ctrl = mdd8_open_channel(SLOT, sizeof(analog_in_out), &analog_in_out);

   /* Interrupt anwhlen */

   mdd8_write_channel_byte(par.handle_ctrl,5);

   /* Kanle, wenn sie nicht mehr bentigt werden, schlieen */

   mdd8_close_channel(&par.handle_1);
   mdd8_close_channel(&par.handle_2);
   mdd8_close_channel(&par.handle_3);
   mdd8_close_channel(&par.handle_4);
   mdd8_close_channel(&par.handle_trig);
   mdd8_close_channel(&par.handle_ctrl);

   /* Wegen Compiler-Warnung */

   kshort = kshort;
   err = err;
   ml8rt_exit();
}


/* --- PDT initialisieren --- */

/* --- PREPARE --- */

void main (void)
{

   pdt.pdt_head.ucType              = 1;
   pdt.pdt_head.ucSize              = sizeof(ML8_PDT_HEAD);
   pdt.pdt_head.usGlobalProc        = 3;
   pdt.pdt_head.usProgNo            = PROGRAM_NUMBER;
   pdt.pdt_head.cVersion            = VERSION;
   pdt.pdt_head.cRevision           = REVISION;
   pdt.pdt_head.ucCPU               = _486DX;
   pdt.pdt_head.ucCoProc            = _NOCOPROZ;
   pdt.pdt_head.ucLanguage          = _CPP31;
   pdt.pdt_head.ucProgType          = _USER_PRG;
   pdt.pdt_head.usFlags             = _NI_TASK + _PDT_INFO_ENABLE + _LOCAL_DATA
                                      + _LOCAL_PARAMETER + _FIXED_DATASIZE;
   pdt.pdt_head.usInt               = 0;
   pdt.pdt_head.ulDataAdr           = 0L;
   pdt.pdt_head.ulDataSize          = 0L;
   pdt.pdt_head.ulDataSizeMin       = 0L;
   pdt.pdt_head.ulDataSizeMax       = 0L;
   ml8rt_phys_adr (&par, &pdt.pdt_head.   ulGlobalParAdr);
   pdt.pdt_head.ulGlobalParAdr      = pdt.pdt_head.ulGlobalParAdr + sizeof(tdt_type);
   pdt.pdt_head.usGlobalParSize     = sizeof(par) - sizeof(tdt_type);
   pdt.pdt_head.ulHyperAdr          = 0L;
   pdt.main_proc                    = main_proc;
   pdt.auto_init                    = auto_init;
   pdt.channel_init                 = channel_init;
   ml8rt_set_pdt_adr (&pdt);
}
