/***************************************************************************/
/**            Ansprechen des MDD fuer M-DC15-2 (MODULAR-4/486)           **/
/**                                                                       **/
/**  Installationshinweise:                                               **/
/**                                                                       **/
/**  Programmnummer  : 2200h                                               **/
/**  Tasknummer      : beliebig                                           **/
/**  Interruptquelle : 0 (wird nicht verwendet, da NI-Task)               **/
/**  Datenbereich    : 0                                                  **/
/**  Flags           : 0980h (nicht aktivieren, Auto-Init aufrufen        **/
/**                                                                       **/
/**                                                                       **/
/**                                                                       **/
/**                     Fr Borland C++ (Version 3.1)                     **/
/**                                                                       **/
/**                             Version 1.C.                              **/
/**                                                                       **/
/**                   Erstellungsdatum : 13.05.97                         **/
/**                    letzte nderung : 06.06.2000 (HK)                  **/
/**                         PDT auf neustem Stand                         **/
/**                             Status : Test                             **/
/**                              Autor : HK                               **/
/**                                                                       **/
/**            (c) 1997 SORCUS Computer GmbH Heidelberg                   **/
/**                                                                       **/
/***************************************************************************/



/* Keine Registervariablen!! */
#pragma option -r-

/* Header fr die Echtzeitbibliothek einbinden */
#include "ml8rtbib.h"
#include "mddcps.h"
#include "MEM.H"
#include "DOS.H"

/* --- Allgemeine Angaben --- */
#define PROGRAM_NUMBER                  0x2200
#define VERSION                         '1'
#define REVISION                        'C'
#define SLOT                            4

/* --- Aufbau der Programm-Descriptor-Tabelle (PDT) --- */

struct pdt_type
   {
   ML8_PDT_HEAD pdt_head;   /* PDT-Header */

   void* PFAR main_proc;    /* Pointer auf  Haupt-Prozedur */
   void* PFAR auto_init;    /* Pointer auf Auto-Init-Prozedur */
   void* PFAR channel_init; /* Pointer auf User-Prozedur */
   } pdt;



/* --- Aufbau des Parameterbereichs --- */

struct parameter_type
   {
   tdt_type tdt;
   HMDD8 handle_1;
   } par;


/****************************************************************************
/*
/*      Module:         M-DC15-2
/*      Hardware ID:    2200h
/*      MDD-Task:       ML8D2200.LIB
/*
/****************************************************************************



/* --- Variable fuer Kanalparameterstruktur --- */

CPS_MDC152 led;

/* Fehlerrecord */

struct {
  USHORT wErrorClass;
  USHORT wErrorCode;
  USHORT wErrorDiagnosis;
  USHORT wFuncID;
  } error_struct;

/* --- Funktionsprototypen --- */
void init_pdt (void);
void main_proc (void);
void auto_init (void);
void channel_init (void);


/* --- main_proc --- */

void main_proc (void)
   {
   ml8rt_entry();
   ml8rt_exit();
   };


void far pascal error_handler(void)
{
  ML8RT_ERROR_INFO_TYPE ep;
  ml8rt_get_error_info(&ep);
  ml8rt_reset_error();
}

void auto_init (void)
{
   ml8rt_entry();
   ml8rt_set_error_handler(&error_handler);
   ml8rt_exit();
}

/* --- channel_init --- */

void channel_init (void)
   {
   CHAR *caption1, *caption1r;
   CHAR *s1;
   ULONG n;
   ULONG l;

   ml8rt_entry();

   /* Define first device */

   led.usDevice         = DEVICE_LED;
   led.usFlags          = 0;
   led.usIndexFirst     = 0;
   led.usIndexLast      = 7;
   led.usWriteMode      = IO_MODE_DIRECT;
   led.usReadMode       = IO_MODE_RAM;
   par.handle_1 = mdd8_open_channel(SLOT, sizeof(led), &led);

   /* Read Info-text of MDD */

   mdd8_read_infotext(SLOT, ITNO_DEVICE_NAME, 80, s1);
   mdd8_read_infotext(SLOT, ITNO_DEVICE_REVISION, 80, s1);
   mdd8_read_infotext(SLOT, ITNO_FIRM_NAME, 80, s1);

   /* Define desciption of channel */

   caption1 = "LED-1";
   n = mdd8_send_channel_control_block(par.handle_1, CTRL_CAPTION, 16, caption1);
   if (n == 10)

   /* Read back description */

     n = mdd8_get_channel_info_block(par.handle_1, INFO_CAPTION, 16, caption1r);

   /* Switch on and off LEDs */
   for (l=0; l<=10; l++) {
     mdd8_write_channel_byte(par.handle_1,_MDC152_LED_0_ON);
     for (n=0;n<=100000;n++) n = n;
     mdd8_write_channel_byte(par.handle_1,_MDC152_LED_1_ON);
     for (n=0;n<=100000;n++) n = n;
     mdd8_write_channel_byte(par.handle_1,_MDC152_LED_0_ON+_MDC152_LED_1_ON);
     for (n=0;n<=100000;n++) n = n;
     mdd8_write_channel_byte(par.handle_1,0);
     for (n=0;n<=100000;n++) n = n;
     }
   ml8rt_exit();
};


/* --- PDT initialisieren --- */

/* --- PREPARE --- */

void main (void)
{

   pdt.pdt_head.ucType            = 1;
   pdt.pdt_head.ucSize            = sizeof(ML8_PDT_HEAD);
   pdt.pdt_head.usGlobalProc      = 3;
   pdt.pdt_head.usProgNo          = PROGRAM_NUMBER;
   pdt.pdt_head.cVersion          = VERSION;
   pdt.pdt_head.cRevision         = REVISION;
   pdt.pdt_head.ucCPU             = _486DX;
   pdt.pdt_head.ucCoProc          = _NOCOPROZ;
   pdt.pdt_head.ucLanguage        = _CPP31;
   pdt.pdt_head.ucProgType        = _USER_PRG;
   pdt.pdt_head.usFlags           = _NI_TASK + _PDT_INFO_ENABLE + _LOCAL_DATA
                                    + _LOCAL_PARAMETER + _FIXED_DATASIZE;
   pdt.pdt_head.usInt             = 0;
   pdt.pdt_head.ulDataAdr         = 0L;
   pdt.pdt_head.ulDataSize        = 0L;
   pdt.pdt_head.ulDataSizeMin     = 0L;
   pdt.pdt_head.ulDataSizeMax     = 0L;
   ml8rt_phys_adr (&par, &pdt.pdt_head.ulGlobalParAdr);
   pdt.pdt_head.ulGlobalParAdr    = pdt.pdt_head.ulGlobalParAdr + sizeof(tdt_type);
   pdt.pdt_head.usGlobalParSize   = sizeof(par) - sizeof(tdt_type);
   pdt.pdt_head.ulHyperAdr        = 0L;
   pdt.main_proc              = main_proc;
   pdt.auto_init              = auto_init;
   pdt.channel_init           = channel_init;
   ml8rt_set_pdt_adr (&pdt);
}
