/***************************************************************************/
/**   Beispiel fr das Ansprechen des MDD fuer M-C16-3  (MODULAR-4/486)   **/
/**                 Alle drei Zhler werden konfiguriert                  **/
/**                                                                       **/
/**  Installationshinweise:                                               **/
/**                                                                       **/
/**  Programmnummer  : 800h                                               **/
/**  Tasknummer      : beliebig                                           **/
/**  Interruptquelle : 0 (wird nicht verwendet, da NI-Task)               **/
/**  Datenbereich    : 0                                                  **/
/**  Flags           : 0980h (nicht aktivieren, Auto-Init aufrufen        **/
/**                                                                       **/
/**                                                                       **/
/**                                                                       **/
/**                     Fr Borland C++ (Version 3.1)                     **/
/**                                                                       **/
/**                             Version 1.B.                              **/
/**                                                                       **/
/**                   Erstellungsdatum : 15.09.97                         **/
/**                    letzte nderung : 05.06.2000                       **/
/**                             Status : Test                             **/
/**                              Autor : HK                               **/
/**                                                                       **/
/**          (c) 1997/2000 SORCUS Computer GmbH Heidelberg                **/
/**                                                                       **/
/***************************************************************************/



/* Keine Registervariablen!! */
#pragma option -r-

/* Header fr die Echtzeitbibliothek einbinden */
#include "ML8RTBIB.H"

/* --- Allgemeine Angaben --- */
#define PROGRAM_NUMBER                  0x800
#define VERSION                         '1'
#define REVISION                        'B'
#define SLOT                            2



typedef struct
{
   ML8_PDT_HEAD   pdt_head;
   void* PFAR     main_proc;           /* address of the main-task-procedure */
   void* PFAR     auto_init;           /* address of Auto-Init procedure     */
   void* PFAR     user_proc;           /* address of User-Proc procedure     */
   void* PFAR     read_counter;        /* Read counter values */
   void* PFAR     read_counter_status; /* Read counter status */
   void* PFAR     int_proc_0;          /* Addresses of the ISR-Routines of the */
   void* PFAR     int_proc_1;          /* 16 Interrupt-channels on the M-C16-3 */
   void* PFAR     int_proc_2;
   void* PFAR     int_proc_3;
   void* PFAR     int_proc_4;
   void* PFAR     int_proc_5;
   void* PFAR     int_proc_6;
   void* PFAR     int_proc_7;
   void* PFAR     int_proc_8;
   void* PFAR     int_proc_9;
   void* PFAR     int_proc_10;
   void* PFAR     int_proc_11;
   void* PFAR     int_proc_12;
   void* PFAR     int_proc_13;
   void* PFAR     int_proc_14;
   void* PFAR     int_proc_15;
} pdt_type;

pdt_type pdt;

/* --- Aufbau des Parameterbereichs --- */

struct parameter_type
   {
   TDT_TYPE tdt;
   USHORT count0;          /* Zhlerwert Kanal 0 */
   USHORT count1;          /* Zhlerwert Kanal 1 */
   USHORT count2;          /* Zhlerwert Kanal 2 */

   USHORT inter;           /* Flag, das anzeigt, welcher Interrupt ausgelst wurde */

   UCHAR status[3];        /* Status der Zhler */

   USHORT din2;            /* Eingnge 0 bis 11 */

   UCHAR led;              /* LED-Status */

   HMDD8 handle_led_0;     /* Handle fr LED 0 */
   HMDD8 handle_led_1;     /* Handle fr LED 0 und 1 */

   HMDD8 handle_din_2;     /* Handle fr digitale Eingnge */

   HMDD8 handle_count_0;   /* Handle fr Zhler 0 */
   HMDD8 handle_count_1;   /* Handle fr Zhler 1 */
   HMDD8 handle_count_2;   /* Handle fr Zhler 2 */

   HMDD8 handle_ctrl_0;    /* Anwahl Interrupt zur Basiskarte */
   HMDD8 handle_ctrl_1;    /* Maskieren/Demaskieren Interrupt-Eingnge */
   HMDD8 handle_ctrl_4;    /* Kanal fr Steuerkommandos an Zhler initialisieren */
   HMDD8 handle_ctrl_5;    /* Lschen eines Pending-Interrupts auf dem Modul */
   } parameter;


/****************************************************************************
/*
/*      Module:         M-C16-3 und M-C16-1
/*      Hardware ID:    2F00h
/*      MDD-Task:       MD82FA00.LIB
/*
/****************************************************************************/

UCHAR command[3];

/* --- Variable fuer Kanalparameterstruktur --- */

CPS_MC163 configuration, intr_ctrl, din, dout, led;


/* --- Funktionsprototypen --- */
void main_proc (void);
void auto_init (void);
void channel_init (void);
void read_channel (void);
void preset_counter (void);

// Reaktion bei Interupt an DIN-0

void int_proc_0 (void)
{
 ml8rt_entry();
 parameter.inter |= 1;
 ml8rt_exit();
}

// Reaktion bei Interupt an DIN-1

void int_proc_1 (void)
{
 ml8rt_entry();
 parameter.inter |= 2;
 ml8rt_exit();
}

// Reaktion bei Interupt an DIN-2

void int_proc_2 (void)
{
 ml8rt_entry();
 parameter.inter |= 4;
 ml8rt_exit();
}

// Reaktion bei Interupt an DIN-3

void int_proc_3 (void)
{
 ml8rt_entry();
 parameter.inter |= 8;
 ml8rt_exit();
}

// Reaktion bei Interupt an DIN-4 oder berlauf Zhler 2

void int_proc_4 (void)
{
 ml8rt_entry();
 mdd8_write_channel_word (parameter.handle_count_2, 0xFF00);
 command[0] = _MC163_CMD_START_COUNTER+
              _MC163_CMD_LOAD_COUNTER+
              _MC163_COUNTER_2;
 /* Steuerkommando schreiben */
 mdd8_write_channel_block (parameter.handle_ctrl_4, 1, &command);
 parameter.inter |= 16;
 ml8rt_exit();
}

// Reaktion bei Interupt an DIN-5 oder Unterlauf Zhler 2
// oder Ende der Messung Zhler 2

void int_proc_5 (void)
{
 ml8rt_entry();
 parameter.inter |= 32;
 ml8rt_exit();
}

// Reaktion bei Interupt an DIN-6 oder berlauf Zhler 1

void int_proc_6 (void)
{
 ml8rt_entry();
 parameter.inter |= 64;
 ml8rt_exit();
}

// Reaktion bei Interupt an DIN-7 oder Unterlauf Zhler 1
// oder Ende der Messung Zhler 1

void int_proc_7 (void)
{
 ml8rt_entry();
 mdd8_write_channel_word (parameter.handle_count_1, 0x0100);
 command[0] = _MC163_CMD_START_COUNTER+
              _MC163_CMD_LOAD_COUNTER+
              _MC163_COUNTER_1;
 /* Steuerkommando schreiben */
 mdd8_write_channel_block (parameter.handle_ctrl_4, 1, &command);
 parameter.inter |= 128;
 ml8rt_exit();
}

// Reaktion bei Interupt an DIN-8

void int_proc_8 (void)
{
 ml8rt_entry();
 parameter.inter |= 256;
 ml8rt_exit();
}

// Reaktion bei Interupt an DIN-9

void int_proc_9 (void)
{
 ml8rt_entry();
 parameter.inter |= 512;
 ml8rt_exit();
}

// Reaktion bei Interupt an DIN-10

void int_proc_10 (void)
{
 ml8rt_entry();
 parameter.inter |= 1024;
 ml8rt_exit();
}

// Reaktion bei Interupt an DIN-11

void int_proc_11 (void)
{
 ml8rt_entry();
 parameter.inter |= 2048;
 ml8rt_exit();
}

// Reaktion bei Interupt an DIN-12 oder berlauf Zhler 0

void int_proc_12 (void)
{
 ml8rt_entry();
 mdd8_write_channel_word (parameter.handle_count_0, 0xFF00);
 command[0] = _MC163_CMD_START_COUNTER+
              _MC163_CMD_LOAD_COUNTER+
              _MC163_COUNTER_0;
 /* Steuerkommando schreiben */
 mdd8_write_channel_block (parameter.handle_ctrl_4, 1, &command);
 parameter.inter |= 4096;
 ml8rt_exit();
}

// Reaktion bei Interupt an DIN-13 oder Unterlauf Zhler 0
// oder Ende der Messung Zhler 0

void int_proc_13 (void)
{
 ml8rt_entry();
 parameter.inter |= 8192;
 ml8rt_exit();
}

// Reaktion bei Interupt an DIN-14 oder Ende der Messung Zhler 0

void int_proc_14 (void)
{
 ml8rt_entry();
 parameter.inter |= 16384;
 ml8rt_exit();
}

// Reaktion bei Interupt an DIN-15 oder Messwert ungltig Zhler 0

void int_proc_15 (void)
{
 ml8rt_entry();
 parameter.inter |= 32768L;
 ml8rt_exit();
}

void read_counter (void)
{
 USHORT countw[3];
 ULONG countd;

 ml8rt_entry();
 command[0] = _MC163_CMD_FREEZE_COUNTER+
              _MC163_COUNTER_0;
 /* Steuerkommando schreiben */
 mdd8_write_channel_block (parameter.handle_ctrl_4, 1, &command);
 command[0] = _MC163_CMD_FREEZE_COUNTER+
              _MC163_COUNTER_1+
              _MC163_COUNTER_2;
 /* Steuerkommando schreiben */
 mdd8_write_channel_block (parameter.handle_ctrl_4, 1, &command);
 parameter.count0 = mdd8_read_channel_word (parameter.handle_count_0);
 parameter.count1 = mdd8_read_channel_word (parameter.handle_count_1);
 parameter.count2 = mdd8_read_channel_word (parameter.handle_count_2);
 parameter.din2 = mdd8_read_channel_word (parameter.handle_din_2);
 if (parameter.led == 2) {
   parameter.led = 1;
   mdd8_write_channel_byte(parameter.handle_led_1,parameter.led);
 }
 else {
   parameter.led = 2;
   mdd8_write_channel_byte(parameter.handle_led_1,parameter.led);
 }
 ml8rt_exit();
}

void read_counter_status (void)
{
 ml8rt_entry();
 /* Status aller Zhler lesen */
 mdd8_read_channel_block (parameter.handle_ctrl_4, 3, parameter.status);
 ml8rt_exit();
}

void preset_counter (void)
{
   mdd8_write_channel_word (parameter.handle_count_0, 0xFF00);
   mdd8_write_channel_word (parameter.handle_count_1, 0x0100);
   mdd8_write_channel_word (parameter.handle_count_2, 0xFF00);
   command[0] = _MC163_CMD_START_COUNTER+
                _MC163_CMD_LOAD_COUNTER+
                _MC163_COUNTER_0;
   /* Steuerkommando schreiben */
   mdd8_write_channel_block (parameter.handle_ctrl_4, 1, &command);
}

/* --- main_proc --- */

void main_proc (void)
{
   ml8rt_entry();
   ml8rt_exit();
}


/* liest Informationen ueber installierte MDDs */

void far pascal error_handler(void)
{
  ML8RT_ERROR_INFO_TYPE* prcError;

  ml8rt_get_error_info(prcError);
/*
  Auswertung
*/
  ml8rt_reset_error();
}

/* --- auto_init --- */

void auto_init (void)
   {
   USHORT i;
   ULONG taskno;

   ml8rt_entry();
   parameter.count0 = 0;               /* Zhlerwerte auf 0 initialisieren */
   parameter.count1 = 0;               /* Zhlerwerte auf 0 initialisieren */
   parameter.count2 = 0;               /* Zhlerwerte auf 0 initialisieren */
   parameter.inter = 0;                /* Interrupt-Flag auf 0 initialisieren */
   ml8rt_set_error_handler(error_handler);      /* Error-Handler definieren */
   taskno = parameter.tdt.task * 65536;         /* Parameter des MDD setzen: */
   for (i=0;i<16;i++)                           /* Task-Nummer dieser Task, Prozedur-Nummern */
     ml8rt_write_par_dword(SLOT,32+(i*4),taskno+4*i); /* der Prozeduren int_proc_0 bis int_proc_15 */
   ml8rt_call_proc(SLOT,2);                     /* User-Init des MDD aufrufen */
   ml8rt_exit();
}

/* --- channel_init --- */
/* liest Informationen ueber installierte MDDs */

void channel_init (void)
   {
   ULONG   date1;

   ml8rt_entry();

   /* CPS-Struktur fr LED initialisieren */

   led.usDevice            = DEVICE_LED;
   led.usIndexFirst        = 0;
   led.usIndexLast         = 0;
   led.usReadMode          = IO_MODE_DIRECT;
   parameter.handle_led_0  = mdd8_open_channel (SLOT, sizeof(led), &led);
   mdd8_write_channel_byte (parameter.handle_led_0 ,0x1);

   led.usDevice            = DEVICE_LED;
   led.usIndexFirst        = 0;
   led.usIndexLast         = 1;
   led.usReadMode          = IO_MODE_DIRECT;
   parameter.handle_led_1  = mdd8_open_channel (SLOT, sizeof(led), &led);
   mdd8_write_channel_byte (parameter.handle_led_1 , 0x3);

   /* CPS-Struktur fr dig. Eingnge initialisieren */

   din.usDevice            = DEVICE_DIN;
   din.usIndexFirst        = 0;
   din.usIndexLast         = 11;
   din.usReadMode          = IO_MODE_DIRECT;
   parameter.handle_din_2  = mdd8_open_channel (SLOT, sizeof(din), &din);

   mdd8_write_channel_word (parameter.handle_din_2 ,0x55);
   date1 = mdd8_read_channel_word (parameter.handle_din_2);
   if (date1 != 0x55) {
     // Fehlerbehandlung
     }

   /* Anwahl Interrupt zur Basiskarte */

   intr_ctrl.usDevice         = DEVICE_CTRL;
   intr_ctrl.usIndexFirst     = 0;
   intr_ctrl.usIndexLast      = 0;
   intr_ctrl.usReadMode       = IO_MODE_DIRECT;
   intr_ctrl.usWriteMode      = IO_MODE_DIRECT;
   parameter.handle_ctrl_0    = mdd8_open_channel (SLOT, sizeof(intr_ctrl), &intr_ctrl);

   mdd8_write_channel_byte (parameter.handle_ctrl_0 ,_MC163_IRQ_D+_MC163_IRQ_POS_EDGE);

   /* Maskieren/Demaskieren der Interrupt-Eingnge */

   intr_ctrl.usDevice         = DEVICE_CTRL;
   intr_ctrl.usFlags          = _CP_EXCLUSIVE;
   intr_ctrl.usIndexFirst     = 1;
   intr_ctrl.usIndexLast      = 1;
   intr_ctrl.usReadMode       = IO_MODE_DIRECT;
   parameter.handle_ctrl_1  = mdd8_open_channel (SLOT, sizeof(intr_ctrl), &intr_ctrl);

   /* Lschen eines Pending-Interrupts auf dem Modul */

   intr_ctrl.usDevice         = DEVICE_CTRL;
   intr_ctrl.usFlags          = _CP_EXCLUSIVE;
   intr_ctrl.usIndexFirst     = 5;
   intr_ctrl.usIndexLast      = 5;
   intr_ctrl.usReadMode       = IO_MODE_DIRECT;
   parameter.handle_ctrl_5    = mdd8_open_channel (SLOT, sizeof(intr_ctrl), &intr_ctrl);

   /* Lschen eines Pending-Interrupts auf dem Modul */

   mdd8_write_channel_byte (parameter.handle_ctrl_5 , 0);

   /* Interrupt INT-0, INT-4, INT-5, INT-6 und INT-7 demaskieren,
      zustzlich soll bei INT-0 und INT-5 die negative Flanke Interrupt auslsen,
      sonst die positive Flanke */

   mdd8_write_channel_dword (parameter.handle_ctrl_1, _MC163_DEMASK_INT_0+
                                                      _MC163_DEMASK_INT_4+
                                                      _MC163_DEMASK_INT_5+
                                                      _MC163_DEMASK_INT_6+
                                                      _MC163_DEMASK_INT_7+
                                                      _MC163_INT_0_NEG_EDGE+
                                                      _MC163_INT_5_NEG_EDGE);

   /* Kanal fr Steuerkommandos an Zhler initialisieren */

   intr_ctrl.usDevice         = DEVICE_CTRL;
   intr_ctrl.usIndexFirst     = 4;
   intr_ctrl.usIndexLast      = 4;
   intr_ctrl.usReadMode       = IO_MODE_DIRECT;
   parameter.handle_ctrl_4    = mdd8_open_channel (SLOT, sizeof(intr_ctrl), &intr_ctrl);


   /* Struktur fr 16-Bit Aufwrtszhler initialisieren */

   configuration.usDevice        = DEVICE_COUNTER;
   configuration.usIndexFirst    = 0;
   configuration.usIndexLast     = 0;
   configuration.usMode          = _MC163_COUNTER_UP;
   configuration.usCounterInput  = _MC163_DIN_4_5_CNT_0;
   configuration.usCounterOutput = _MC163_DOUT_0_CNT_0;
   configuration.usCommandInput  = _MC163_START_DIN_0+
                                   _MC163_STOP_DIN_1+
                                   _MC163_STOP_UFL_CNT_1+
                                   _MC163_LOAD_DIN_0+
                                   _MC163_FREEZE_DIN_1+
                                   _MC163_RESET_DIN_0;
   configuration.usInterrupt     = _MC163_INT_CNT_0_OVL+
                                   _MC163_INT_CNT_0_UFL+
                                   _MC163_INT_CNT_0_END+
                                   _MC163_INT_CNT_0_INVALID;
   configuration.usTime          = _MC163_1_MHZ;
   configuration.usMultiple      = 0;
   configuration.usFlags         = 0;
   configuration.usReadMode      = IO_MODE_DIRECT;
   configuration.usWriteMode     = IO_MODE_DIRECT;
   parameter.handle_count_0      = mdd8_open_channel (SLOT, sizeof(configuration), &configuration);

   mdd8_write_channel_word (parameter.handle_count_0, 0xFF00);

   /* Struktur fr 16-Bit Abwrtszhler initialisieren */

   configuration.usDevice        = DEVICE_COUNTER;
   configuration.usIndexFirst    = 1;
   configuration.usIndexLast     = 1;
   configuration.usMode          = _MC163_COUNTER_DN;
   configuration.usCounterInput  = _MC163_DIN_6_CNT_1;
   configuration.usCounterOutput = _MC163_DOUT_1_CNT_1;
   configuration.usCommandInput  = _MC163_START_DIN_1+
                                   _MC163_STOP_DIN_2+
                                   _MC163_LOAD_DIN_1+
                                   _MC163_FREEZE_DIN_2+
                                   _MC163_RESET_DIN_1;
   configuration.usInterrupt     = _MC163_INT_CNT_1_OVL+
                                   _MC163_INT_CNT_1_UFL+
                                   _MC163_INT_CNT_1_END;
   configuration.usTime          = _MC163_1_MHZ;
   configuration.usMultiple      = 0;
   configuration.usReadMode      = IO_MODE_DIRECT;
   configuration.usWriteMode     = IO_MODE_DIRECT;

   parameter.handle_count_1      = mdd8_open_channel (SLOT, sizeof(configuration), &configuration);

   mdd8_write_channel_word (parameter.handle_count_1,0x0100);

   /* Struktur fr Auf-/Abwrtszhler initialisieren */

   configuration.usDevice        = DEVICE_COUNTER;
   configuration.usIndexFirst    = 2;
   configuration.usIndexLast     = 2;
   configuration.usMode          = _MC163_COUNTER_UP_DN_B;
   configuration.usCounterInput  = _MC163_DIN_4_CNT_2;
   configuration.usCounterOutput = _MC163_DOUT_2_CNT_2;
   configuration.usCommandInput  = _MC163_START_DIN_2+
                                   _MC163_STOP_DIN_3+
                                   _MC163_LOAD_DIN_2+
                                   _MC163_FREEZE_DIN_3+
                                   _MC163_RESET_DIN_2;
   configuration.usInterrupt     = _MC163_INT_CNT_2_OVL+
                                   _MC163_INT_CNT_2_UFL+
                                   _MC163_INT_CNT_2_END;
   configuration.usTime          = _MC163_1_MHZ;
   configuration.usMultiple      = 0;
   configuration.usReadMode      = IO_MODE_DIRECT;
   configuration.usWriteMode     = IO_MODE_DIRECT;

   parameter.handle_count_2 = mdd8_open_channel (SLOT, sizeof(configuration), &configuration);

   mdd8_write_channel_word (parameter.handle_count_2,0xFF00);

   /* Counter 0 bis 2 laden und starten */

   command[0] = _MC163_CMD_START_COUNTER+
                _MC163_CMD_LOAD_COUNTER+
                _MC163_COUNTER_0;
   command[1] = _MC163_CMD_START_COUNTER+
                _MC163_CMD_LOAD_COUNTER+
                _MC163_COUNTER_1;
   command[2] = _MC163_CMD_START_COUNTER+
                _MC163_CMD_LOAD_COUNTER+
                _MC163_COUNTER_2;
   mdd8_write_channel_block (parameter.handle_ctrl_4, 3, &command);
   ml8rt_unmask_int(IRQ_SLAVE + _MC163_IRQ_D);

  /* Pending Interrupts auf dem Modul lschen */

  mdd8_write_channel_byte (parameter.handle_ctrl_5 , 0);
  ml8rt_exit();
}




pdt_type pdt;

/* --- PDT initialisieren --- */

void main (void)                       /* PREPARE                          */
{

	pdt.pdt_head.ucType          = 1;                   /* set PDT-type                     */
	pdt.pdt_head.ucSize          = sizeof(ML8_PDT_HEAD);/* length of PDT-header          */
	pdt.pdt_head.usGlobalProc    = 21;                  /* number of procedures             */
	pdt.pdt_head.usProgNo        = PROGRAM_NUMBER;      /* program-number                   */
	pdt.pdt_head.cVersion        = VERSION;             /* program-version                  */
	pdt.pdt_head.cRevision       = REVISION;            /* program-revision                */
	pdt.pdt_head.ucCPU           = _486DX;              /* CPU-type                         */
	pdt.pdt_head.ucCoProc        = _NOCOPROZ;           /* Co-Prozessor-type                */
	pdt.pdt_head.ucLanguage      = _CPP31;              /* program-language = C++           */
	pdt.pdt_head.ucProgType      = _USER_PRG;           /* program-type: user-program       */
	pdt.pdt_head.usFlags         = _NI_TASK + _PDT_INFO_ENABLE + _LOCAL_DATA
                                  + _LOCAL_PARAMETER + _FIXED_DATASIZE;
	pdt.pdt_head.usInt           = 0;                   /* interrupt-number                 */
	pdt.pdt_head.ulDataAdr       = 0;                   /* address of data-range            */
	pdt.pdt_head.ulDataSize      = 0;                   /* size of data-range               */
	pdt.pdt_head.ulDataSizeMin   = 0;                   /* min. size of data-range          */
	pdt.pdt_head.ulDataSizeMax   = 0;                   /* max. size of data-range          */
													                /* start address of parameter-range */
	ml8rt_phys_adr(&parameter,&pdt.pdt_head.ulGlobalParAdr);
   pdt.pdt_head.ulGlobalParAdr  = pdt.pdt_head.ulGlobalParAdr + sizeof(TDT_TYPE);
													                /* number of parameter              */
	pdt.pdt_head.usGlobalParSize = sizeof(parameter) - sizeof(TDT_TYPE);
	pdt.pdt_head.ulHyperAdr      = 0;                   /* address of hypertext-range       */
	pdt.main_proc                = main_proc;           /* address of main procedure        */
	pdt.auto_init                = auto_init;           /* address of auto_init procedure   */
	pdt.user_proc                = channel_init;        /* address of channel_init procedure   */
   pdt.read_counter             = read_counter;        /* address of counter read procedure */
   pdt.read_counter_status      = read_counter_status; /* address of counter status read procedure */
   pdt.int_proc_0               = int_proc_0;          /* addresses of the 16 ISR procedures */
	pdt.int_proc_1               = int_proc_1;
	pdt.int_proc_2               = int_proc_2;
	pdt.int_proc_3               = int_proc_3;
   pdt.int_proc_4               = int_proc_4;
	pdt.int_proc_5               = int_proc_5;
	pdt.int_proc_6               = int_proc_6;
	pdt.int_proc_7               = int_proc_7;
   pdt.int_proc_8               = int_proc_8;
	pdt.int_proc_9               = int_proc_9;
	pdt.int_proc_10              = int_proc_10;
	pdt.int_proc_11              = int_proc_11;
   pdt.int_proc_12              = int_proc_12;
	pdt.int_proc_13              = int_proc_13;
	pdt.int_proc_14              = int_proc_14;
	pdt.int_proc_15              = int_proc_15;
   ml8rt_set_pdt_adr(&pdt);     /* return address of PDT to OS      */
}

