/********************************************************************
*  This is the header file of the on-board real-time-library for
*  all SORCUS boards.
*
*  Author         HK
*
*  Last change    22/09/98  Support of ML7
*
*  Author         Dipl.-Ing. H.Doersam
*
*  Last change    27/03/98
*
*  Copyrights by SORCUS Computer GmbH 1998
*  All rights reserved.
********************************************************************/


// Defines for Preprocessor:
//
// __MLXMACRO__         To include the MLx macros (is set by header
//                      file mlXrtbib.h in dependency of define
//                      USE_MLx_MACROS)
//
// __BORLANDC__         To compile with Borland C compiler. 
//                      The define is already done by the compiler.
//
// _MSC_VER             To compile with Microsoft C compiler. 
//                      The define is already done by the compiler.
//
// __LARGE__            Only Borland C: Memory model LARGE. 
//                      The define is already done by the compiler.
//
// _M_I86LM             Only Microsoft C: Memory model LARGE. 
//                      The define is already done by the compiler.
//
// __BUILD_RTBIB__      To build the library ML8RTBIB
//
// __BUILD_PASCAL__     To build the library ML8RTBIB for Pascal
//
// __ML6__              Include header files for Multi-COM
//
// __ML7__              Include header files for MODULAR-4/486 "short"
//
// __ML8__              Include header files for MODULAR-4/486
//
// __SCI__              Only for SORCUS internal projects





#ifndef _INC_MLXRT
#define _INC_MLXRT



#ifdef  __BORLANDC__

/********************************************************************
*  EXCLUSIVE FOR BORLAND C
********************************************************************/

// Memory model must be LARGE !
#ifndef __LARGE__
#error Wrong code model, use code model LARGE!
#endif // !__LARGE__

#define RTBIBAPI

#define PFAR far pascal

#define PVAR pascal

#define EXTERNAL extern

#define INTERNAL static

// Compatibility to version < 4.A
#define EXPORT far pascal

// Use no register variables
#pragma -r-

// Use byte alignment
#pragma -a-

#include <DOS.H>

#endif // __BORLANDC__




#ifdef _MSC_VER

/********************************************************************
*  EXCLUSIVE FOR MICROSOFT C
********************************************************************/

// Memory model must be LARGE !
#ifndef _M_I86LM
#error Wrong code model, use code model LARGE!
#endif // !_M_I86LM

#define RTBIBAPI

#define PFAR __far __pascal

#define PVAR pascal

#define EXTERNAL extern

#define INTERNAL static

#endif // _MSC_VER




/********************************************************************
*  FOR ALL COMPILERS
********************************************************************/



#include <MLXRTTYP.H>         // Types (structs)
#include <MLXRTDEF.H>         // Constants (defines)
#include <MDDCPS.H>           // Types and constants for the MDDs

#ifdef __MLXMACRO__
#include <MLXMACRO.H>         // Macros
#endif // __MLXMACRO__

                              // Only SORCUS internal
#ifdef __SCI__
#include <MLXRTSCI.H>
#endif // __SCI__
                              // ONLY MODULAR-4/486 (ML8)
#ifdef __ML8__
#include <ML8RTPRO.H>         // Prototypes
#endif // __ML8__
                              // ONLY MODULAR-4/486 (ML7) "short"
#ifdef __ML7__
#include <ML7RTPRO.H>         // Prototypes
#endif // __ML7__
                              // ONLY MULTI-COM (ML6)
#ifdef __ML6__
#include <ML6RTPRO.H>         // Prototypes
#endif // __ML6__




#endif // !_INC_MLXRT


