/************************************************************************/
/*   MSG_MDD.H - Header for the DLL functions mdd_open_channel_callback */
/*               and mdd_close_channel and also for the MSG_MDD         */
/*                                                                      */
/*   Created   15.12.1999                                               */
/*   by        JD                                                       */
/*                                                                      */
/************************************************************************/

// identification of a MSG_MDD_DATA data structure in the library
#define MSG_MDD_DATA_KEY	0x4B444D4DL //"MMDK"

// reserved SRQ-low-byte for message MDD
#define SRQ_MDD_CALLBACK	0xCD

// osx-program number of message-MDD
#define PRG_NR_MSG_MDD		0x440
#define PRG_NAME_MSG_MDD   "msg_mdd.exe"

// definitions for the MsgMdd CPS-flags
#define SYNC_CALLBACK		0x0002	// asynchronous callback without buffer (RT-only)

// types of the devices of the Message MDD
#define DEVICE_SRQ_RCV		0x0D02
#define DEVICE_SRQ_TMT		0x0D03

// max. number of bytes in a channel-block command
#define MDD_MAX_BLOCKSIZE	256

#define DEFAULT_MSG_MDD_TASK_NO		0xCD
#define DEFAULT_MSG_MDD_PATH			"c:\\sorcus\\ml8\\mdd\\"
// offset of buffer-size-parameter in message-MDD-Parameter range
#define MSG_MDD_PAR_BUFFER_SIZE  40
// offset of status parameter in message-MDD-Parameter range
#define MSG_MDD_PAR_STATUS			0
// ok value for parameter 0: task is ready
#define MSG_MDD_STATUS_OK			0x10		

#ifndef __BORLANDC__
   #pragma pack(push, SORCPACK, 2)
#else
   #pragma option -a
#endif

// data structure installed in the DLL for each write-channel opened
// to the Message-MDD
typedef struct MSG_MDD_DATA_TYPE {
	HMDD8		hModulChannel;	// handle of the channel to the modul-MDD (known by the user)
	HMDD8		hMsgWChannel;  // handle of the channel to the message-MDD (internal)
	ULONG		ulExtra;			// reserved (parameter from user)
	ULONG		ulKey;			// identification of this structure
	void		(*pfnUserFunction) (HMDD8 handle, ULONG par, ULONG size, void *data); // user callback porocedure
	struct MSG_MDD_DATA_TYPE *prcPrev; // previous data struct address
	USHORT	usMddTask;		// task number of the MDD of hModulChannel
} MSG_MDD_DATA;

// first bytes in a channnel write access
typedef
 struct {								// do not change the order in the struct !
   USHORT		usSize;                 // number of bytes that follow in the buffer
   ULONG			ulHostHandle;				// address of the corresponding host-library data struct
} srq_header_type;

typedef struct {
	USHORT	      usDevice;            // type of the device RCV, TMT
	USHORT	      usFlags;             // properties
	USHORT	      usHost;              // number of host of user callback (0=this CPU)
   USHORT	      usSrqWord;           // srq to send to host (0=this CPU)
   ULONG				ulHostHandle;        // address of library with further info about user callback
													// or in RT the address of the callback procedure
} CPS_MSG;

#ifndef __BORLANDC__
   #pragma pack(pop, SORCPACK)
#else
   #pragma option -a.
#endif

