{****************************************************************************}
{**  Beispiel fr MDD M-DC15-2                                             **}
{**                                                                        **}
{**                                                                        **}
{**  Installationshinweise:                                                **}
{**                                                                        **}
{**  Programmnummer  : 800h                                                **}
{**  Tasknummer      : beliebig                                            **}
{**  Interruptquelle : NI                                                  **}
{**  Datenbereich    : 0                                                   **}
{**  Flags           : 0980h (Task nicht aktiviert, Auto-Init aufrufen)    **}
{**                                                                        **}
{**                       TURBO-PASCAL (Version 7.0)                       **}
{**                                                                        **}
{**                             Version 2.B.                               **}
{**                                                                        **}
{**                   Erstellungsdatum : 28.09.92                          **}
{**                    letzte nderung : 06.06.2000 (HK)                   **}
{**                             Status :                                   **}
{**                              Autor : H.K.                              **}
{**                                                                        **}
{**    (c) 1992, 1993, 1994, 1997 SORCUS Computer GmbH Heidelberg          **}
{**                                                                        **}
{****************************************************************************}
{$N+}                                     { Coprozessor ein }
{$E+}                                     { keine Emulation }
{$R-}                                     { kein Range-Check }
{$S-}                                     { kein Stack-Checking }
{$I-}                                     { kein IO-Checking }
{$V-}                                     { Keine strikte Stringbergabe }
{$L+}                                     { Local-Symbols fr Turbo-Debugger }
{$F+}                                     { FAR Aufrufe erzwingen! }
{$M 1024, 0, 0}                           { Stack und Heap auf Minimum }

uses ml8rtbib,
     mddcps;                            { Die ML8 On-Board Bibliothek einbinden }

Const                        { ***** ALLGEMEINE ANGABEN ***** }
   Programm_Number      : Word = $800;    { Programmnummer = 800h }
   Version              : Char = '2';     { Version des Porgramms }
   Revision             : Char = 'B';     { Revision des Programms }

   SLOT                 = 4; { Steckplatz 4 }

                             { ***** Aufbau der Programm-Descriptor-Tabelle (PDT) ***** }
Type
   PDT_Type             = Record
                             PDT_HEAD : ML8_PDT_HEAD;  { PDT-Header }

                             Main          : Pointer;  { Adresse der Haupt-Prozedur (Task-Prozedur) }
                             Auto_Init     : Pointer;  { Adresse der Auto-Init-Prozedur }
                             Channel_Init  : Pointer;  { Adresse der Start-Prozedur }
                          end;

                             { ***** DEKLARATION DER GLOBALEN PROGRAMMDATEN ***** }
VAR
   PDT                  : PDT_Type;                    { Deklaration der Kopftabelle }

                             { ***** Parameterbereich des Programms deklarieren. ***** }
                             { Auf diese Daten kann spter ber das Betriebssystem zugegriffen werden. }
   Parameter            : Record
                             TDT       : TDT_Type;     { Platz fr die TDT reservieren }
                             handle_1  : HMDD8;
                             end;

   error_struct : record
                     wErrorClass:     Word;
                     wErrorCode:      Word;
                     wErrorDiagnosis: Word;
                     wFuncID:         Word;
                     end;

   led: CPS_MDC152;


procedure error_handler;
var
   err : ML8RT_ERROR_INFO_TYPE;
begin
  ml8rt_get_error_info(err);
end;

Procedure Main_Proc;         { ***** HAUPTPROZEDUR (NI-Task) ***** }
begin
   ml8rt_entry;
   ml8rt_exit;
end;

procedure auto_init;
begin

   ml8rt_entry;
   ml8rt_set_error_handler(@error_handler);
   ml8rt_exit;

end;

(* --- channel_init --- *)

procedure channel_init;
var
   caption1, caption1r: string;
   s1: string;
   n: longint;
   l: longint;

begin
   ml8rt_entry;

   (* Define first device *)

   led.usDevice         := DEVICE_LED;
   led.usFlags          := 0;
   led.usIndexFirst     := 0;
   led.usIndexLast      := 7;
   led.usWriteMode      := IO_MODE_DIRECT;
   led.usReadMode       := IO_MODE_RAM;

   parameter.handle_1 := mdd8_open_channel(SLOT, sizeof(led), led);

   (* Read Info-text of MDD *)

   mdd8_read_infotext(SLOT, ITNO_DEVICE_NAME, 80, s1);
   mdd8_read_infotext(SLOT, ITNO_DEVICE_REVISION, 80, s1);
   mdd8_read_infotext(SLOT, ITNO_FIRM_NAME, 80, s1);

   (* Define desciption of channel *)

   caption1 := 'LED-1';
   n := mdd8_send_channel_control_block(parameter.handle_1, CTRL_CAPTION, 16, caption1);
   if (n = 10) then

   (* Read back description *)

     n := mdd8_get_channel_info_block(parameter.handle_1, INFO_CAPTION, 16, caption1r);

   (* Switch on and off LEDs *)

   for l := 0 to 10 do
     begin
       mdd8_write_channel_byte(parameter.handle_1,_MDC152_LED_0_ON);
       for n := 0 to 100000 do n := n;
       mdd8_write_channel_byte(parameter.handle_1,_MDC152_LED_1_ON);
       for n := 0 to 100000 do n := n;
       mdd8_write_channel_byte(parameter.handle_1,_MDC152_LED_0_ON+_MDC152_LED_1_ON);
       for n := 0 to 100000 do n := n;
       mdd8_write_channel_byte(parameter.handle_1,0);
       for n := 0 to 100000 do n := n;
     end;
   ml8rt_exit;
end;

Procedure Init_PDT;
begin                                           { Die Prozedur stellt alle Werte in der Kopftabelle ein }
   PDT.PDT_HEAD.ucType := 1;                    { Programm-Descriptor-Tabellen-Typ
                                                  (im Moment wird nur der Typ 1 untersttzt) }
   PDT.PDT_HEAD.ucSize := sizeof(ML8_PDT_HEAD); { Gre des Vorspanns der Kopftabelle (im Moment immer = _PDT_Length = 48) }
   PDT.PDT_HEAD.usGlobalProc := 3;              { Anzahl der Prozeduren
                                                  (in diesem Beispiel Auto_Init, Main_Proc, Start, Stop, ...}
   PDT.PDT_HEAD.usProgNo := Programm_Number;    { Programm-Nummer }
   PDT.PDT_HEAD.cVersion := Version;            { Programm-Version }
   PDT.PDT_HEAD.cRevision := Revision;          { Programm-Revision }
   PDT.PDT_HEAD.ucCPU := _486SX;                { CPU-Typ }
   PDT.PDT_HEAD.ucCoProc := _NOCOPROZ;          { Co-Prozessor-Typ }
   PDT.PDT_HEAD.ucLanguage := _TP70;            { Programmiersprache }
   PDT.PDT_HEAD.ucProgType := _User_Prg;        { Programm-Typ: Anwenderprogramm }
   PDT.PDT_HEAD.usFlags := $0;                  { Flags }
   PDT.PDT_HEAD.usFlags := _NI_Task + _Local_Data + _Local_Parameter + _Fixed_Datasize;
   PDT.PDT_HEAD.usInt := 0;                     { Interrupt-Nummer wird bei der Installierung angegeben }
   PDT.PDT_HEAD.ulDataAdr := 0;                 { Adresse des Datenbereichs }
   PDT.PDT_HEAD.ulDataSize := 0;                { Gre des Datenbereichs }
   PDT.PDT_HEAD.ulDataSizeMin := 0;             { Minimaler Datenbereich }
   PDT.PDT_HEAD.ulDataSizeMax := 0;             { Maximaler Datenbereich }
                                                { Anfangsadresse des Parameterbereichs }
   ml8rt_phys_adr (@Parameter, PDT.PDT_HEAD.ulGlobalParAdr);
   PDT.PDT_HEAD.ulGlobalParAdr := PDT.PDT_HEAD.ulGlobalParAdr + SizeOf(TDT_Type);
                                                { Anzahl der Parameter }
   PDT.PDT_HEAD.usGlobalParSize := SizeOf(Parameter) - SizeOf(TDT_Type);
   PDT.PDT_HEAD.ulHyperAdr := 0;                { Adresse des Hypertextes (wird nicht benutzt) }
   PDT.PDT_HEAD.usRes1 := 0;
   PDT.PDT_HEAD.ulRes2 := 0;
   PDT.Main := @Main_Proc;                      { Adresse der Hauptprozedur }
   PDT.Auto_Init := @Auto_Init;                 { Adresse der Auto-Init-Prozedur }
   PDT.Channel_Init := @Channel_Init;           { Adresse der Start-Prozedur }
end;

begin                        { ***** PREPARE ***** }
   Init_PDT;                              { PDT initialisieren }
   ml8rt_Set_PDT_Adr (PDT);               { Adresse der PDT im Rckgabe-Record dem Betriebssystem bergeben }
end.
