(***************************************************************************)
(**   Beispiel fr das Ansprechen des MDD fuer M-C16-3  (MODULAR-4/486)   **)
(**                 Alle drei Zhler werden konfiguriert                  **)
(**                                                                       **)
(**  Installationshinweise:                                               **)
(**                                                                       **)
(**  Programmnummer  : 800h                                               **)
(**  Tasknummer      : beliebig                                           **)
(**  Interruptquelle : 0 (wird nicht verwendet, da NI-Task)               **)
(**  Datenbereich    : 0                                                  **)
(**  Flags           : 0980h (nicht aktivieren, Auto-Init aufrufen        **)
(**                                                                       **)
(**                                                                       **)
(**                                                                       **)
(**                     Fr Borland C++ (Version 3.1)                     **)
(**                                                                       **)
(**                             Version 1.B.                              **)
(**                                                                       **)
(**                   Erstellungsdatum : 15.09.97                         **)
(**                    letzte nderung : 05.06.2000                       **)
(**                             Status : Test                             **)
(**                              Autor : HK                               **)
(**                                                                       **)
(**          (c) 1997/2000 SORCUS Computer GmbH Heidelberg                **)
(**                                                                       **)
(***************************************************************************)



(* Keine Registervariablen!! *)

(* Header fr die Echtzeitbibliothek einbinden *)
uses
    ML8RTBIB,MDDCPS;

(* --- Allgemeine Angaben --- *)
const
     PROGRAM_NUMBER = $800;
     VERSION = '1';
     REVISION = 'B';
     SLOT = 2;


Type
    pdt_type = Record
               PDT_HEAD   : ML8_PDT_HEAD;
               main_proc  : Pointer;           (* address of the main-task-procedure *)
               auto_init  : Pointer;           (* address of Auto-Init procedure     *)
               user_proc  : Pointer;           (* address of User-Proc procedure     *)
               read_counter  : Pointer;        (* Read counter values *)
               read_counter_status  : Pointer; (* Read counter status *)
               int_proc_0  : Pointer;          (* Addresses of the ISR-Routines of the *)
               int_proc_1  : Pointer;          (* 16 Interrupt-channels on the M-C16-3 *)
               int_proc_2  : Pointer;
               int_proc_3  : Pointer;
               int_proc_4  : Pointer;
               int_proc_5  : Pointer;
               int_proc_6  : Pointer;
               int_proc_7  : Pointer;
               int_proc_8  : Pointer;
               int_proc_9  : Pointer;
               int_proc_10 : Pointer;
               int_proc_11 : Pointer;
               int_proc_12 : Pointer;
               int_proc_13 : Pointer;
               int_proc_14 : Pointer;
               int_proc_15 : Pointer;
               end;

var
   pdt: pdt_type;

(* --- Aufbau des Parameterbereichs --- *)

   parameter : record
               tdt: TDT_TYPE ;
               count0: Word ;          (* Zhlerwert Kanal 0 *)
               count1: Word ;          (* Zhlerwert Kanal 1 *)
               count2: Word ;          (* Zhlerwert Kanal 2 *)

               inter: Word ;           (* Flag, das anzeigt, welcher Interrupt ausgelst wurde *)

               status: array[1..3] of byte;        (* Status der Zhler *)

               din2: Word ;            (* Eingnge 0 bis 11 *)

               led: byte;              (* LED-Status *)

               handle_led_0: HMDD8 ;     (* Handle fr LED 0 *)
               handle_led_1: HMDD8 ;     (* Handle fr LED 0 und 1 *)

               handle_din_2: HMDD8 ;     (* Handle fr digitale Eingnge *)

               handle_count_0: HMDD8 ;   (* Handle fr Zhler 0 *)
               handle_count_1: HMDD8 ;   (* Handle fr Zhler 1 *)
               handle_count_2: HMDD8 ;   (* Handle fr Zhler 2 *)

               handle_ctrl_0: HMDD8 ;    (* Anwahl Interrupt zur Basiskarte *)
               handle_ctrl_1: HMDD8 ;    (* Maskieren/Demaskieren Interrupt-Eingnge *)
               handle_ctrl_4: HMDD8 ;    (* Kanal fr Steuerkommandos an Zhler initialisieren *)
               handle_ctrl_5: HMDD8 ;    (* Lschen eines Pending-Interrupts auf dem Modul *)
               end;


(****************************************************************************
(*
(*      Module:         M-C16-3 und M-C16-1
(*      Hardware ID:    2F00h
(*      MDD-Task:       MD82FA00.LIB
(*
(****************************************************************************)

   command: array[1..3] of byte;

(* --- Variable fuer Kanalparameterstruktur --- *)

   configuration, intr_ctrl, din, dout, led: CPS_MC163 ;


(* Reaktion bei Interupt an DIN-0 *)

procedure int_proc_0 ;
begin
 ml8rt_entry;
 parameter.inter := parameter.inter or 1;
 ml8rt_exit;
end;

(* Reaktion bei Interupt an DIN-1 *)

procedure int_proc_1 ;
begin
 ml8rt_entry;
 parameter.inter := parameter.inter or 2;
 ml8rt_exit;
end;

(* Reaktion bei Interupt an DIN-2 *)

procedure int_proc_2 ;
begin
 ml8rt_entry;
 parameter.inter := parameter.inter or 4;
 ml8rt_exit;
end;

(* Reaktion bei Interupt an DIN-3 *)

procedure int_proc_3 ;
begin
 ml8rt_entry;
 parameter.inter := parameter.inter or 8;
 ml8rt_exit;
end;

(* Reaktion bei Interupt an DIN-4 oder berlauf Zhler 2 *)

procedure int_proc_4 ;
begin
 ml8rt_entry;
 mdd8_write_channel_word (parameter.handle_count_2, $FF00);
 command[1] := _MC163_CMD_START_COUNTER+
               _MC163_CMD_LOAD_COUNTER+
               _MC163_COUNTER_2;
 (* Steuerkommando schreiben *)
 mdd8_write_channel_block (parameter.handle_ctrl_4, 1, command);
 parameter.inter := parameter.inter or 16;
 ml8rt_exit;
end;

(* Reaktion bei Interupt an DIN-5 oder Unterlauf Zhler 2
   oder Ende der Messung Zhler 2 *)

procedure int_proc_5 ;
begin
 ml8rt_entry;
 parameter.inter := parameter.inter or 32;
 ml8rt_exit;
end;

(* Reaktion bei Interupt an DIN-6 oder berlauf Zhler 1 *)

procedure int_proc_6 ;
begin
 ml8rt_entry;
 parameter.inter := parameter.inter or 64;
 ml8rt_exit;
end;

(* Reaktion bei Interupt an DIN-7 oder Unterlauf Zhler 1
   oder Ende der Messung Zhler 1 *)

procedure int_proc_7 ;
begin
 ml8rt_entry;
 mdd8_write_channel_word (parameter.handle_count_1, $0100);
 command[1] := _MC163_CMD_START_COUNTER+
              _MC163_CMD_LOAD_COUNTER+
              _MC163_COUNTER_1;
 (* Steuerkommando schreiben *)
 mdd8_write_channel_block (parameter.handle_ctrl_4, 1, command);
 parameter.inter := parameter.inter or 128;
 ml8rt_exit;
end;

(* Reaktion bei Interupt an DIN-8 *)

procedure int_proc_8 ;
begin
 ml8rt_entry;
 parameter.inter := parameter.inter or 256;
 ml8rt_exit;
end;

(* Reaktion bei Interupt an DIN-9 *)

procedure int_proc_9 ;
begin
 ml8rt_entry;
 parameter.inter := parameter.inter or 512;
 ml8rt_exit;
end;

(* Reaktion bei Interupt an DIN-10 *)

procedure int_proc_10 ;
begin
 ml8rt_entry;
 parameter.inter := parameter.inter or 1024;
 ml8rt_exit;
end;

(* Reaktion bei Interupt an DIN-11 *)

procedure int_proc_11 ;
begin
 ml8rt_entry;
 parameter.inter := parameter.inter or 2048;
 ml8rt_exit;
end;

(* Reaktion bei Interupt an DIN-12 oder berlauf Zhler 0 *)

procedure int_proc_12 ;
begin
 ml8rt_entry;
 mdd8_write_channel_word (parameter.handle_count_0, $FF00);
 command[1] := _MC163_CMD_START_COUNTER+
               _MC163_CMD_LOAD_COUNTER+
               _MC163_COUNTER_0;
 (* Steuerkommando schreiben *)
 mdd8_write_channel_block (parameter.handle_ctrl_4, 1, command);
 parameter.inter := parameter.inter or 4096;
 ml8rt_exit;
end;

(* Reaktion bei Interupt an DIN-13 oder Unterlauf Zhler 0
   oder Ende der Messung Zhler 0 *)

procedure int_proc_13 ;
begin
 ml8rt_entry;
 parameter.inter := parameter.inter or 8192;
 ml8rt_exit;
end;

(* Reaktion bei Interupt an DIN-14 oder Ende der Messung Zhler 0 *)

procedure int_proc_14 ;
begin
 ml8rt_entry;
 parameter.inter := parameter.inter or 16384;
 ml8rt_exit;
end;

(* Reaktion bei Interupt an DIN-15 oder Messwert ungltig Zhler 0 *)

procedure int_proc_15 ;
begin
 ml8rt_entry;
 parameter.inter := parameter.inter or 32768;
 ml8rt_exit;
end;

procedure read_counter ;
var
   countw: array[1..3] of word;
   countd: longint;
begin
 ml8rt_entry;
 command[1] := _MC163_CMD_FREEZE_COUNTER+
               _MC163_COUNTER_0;
 (* Steuerkommando schreiben *)
 mdd8_write_channel_block (parameter.handle_ctrl_4, 1, command);
 command[1] := _MC163_CMD_FREEZE_COUNTER+
               _MC163_COUNTER_1+
               _MC163_COUNTER_2;
 (* Steuerkommando schreiben *)
 mdd8_write_channel_block (parameter.handle_ctrl_4, 1, command);
 parameter.count0 := mdd8_read_channel_word (parameter.handle_count_0);
 parameter.count1 := mdd8_read_channel_word (parameter.handle_count_1);
 parameter.count2 := mdd8_read_channel_word (parameter.handle_count_2);
 parameter.din2 := mdd8_read_channel_word (parameter.handle_din_2);
 if (parameter.led = 2) then
 begin
   parameter.led := 1;
   mdd8_write_channel_byte(parameter.handle_led_1,parameter.led);
 end
 else
 begin
   parameter.led := 2;
   mdd8_write_channel_byte(parameter.handle_led_1,parameter.led);
 end;
 ml8rt_exit;
end;

procedure read_counter_status ;
begin
 ml8rt_entry;
 (* Status aller Zhler lesen *)
 mdd8_read_channel_block (parameter.handle_ctrl_4, 3, parameter.status);
 ml8rt_exit;
end;

procedure preset_counter ;
begin
   mdd8_write_channel_word (parameter.handle_count_0, $FF00);
   mdd8_write_channel_word (parameter.handle_count_1, $0100);
   mdd8_write_channel_word (parameter.handle_count_2, $FF00);
   command[1] := _MC163_CMD_START_COUNTER+
                 _MC163_CMD_LOAD_COUNTER+
                 _MC163_COUNTER_0;
   (* Steuerkommando schreiben *)
   mdd8_write_channel_block (parameter.handle_ctrl_4, 1, command);
end;

(* --- main_proc --- *)

procedure main_proc ;
begin
   ml8rt_entry;
   ml8rt_exit;
end;


(* liest Informationen ueber installierte MDDs *)

procedure error_handler; far;
var

  prcError: ML8RT_ERROR_INFO_TYPE;

begin

  ml8rt_get_error_info(prcError);
(*
  Auswertung
*)
  ml8rt_reset_error;
end;

(* --- auto_init --- *)

procedure auto_init ;
var
   i: Word;
   taskno: longint;
begin
   ml8rt_entry;
   parameter.count0 := 0;               (* Zhlerwerte auf 0 initialisieren *)
   parameter.count1 := 0;               (* Zhlerwerte auf 0 initialisieren *)
   parameter.count2 := 0;               (* Zhlerwerte auf 0 initialisieren *)
   parameter.inter := 0;                (* Interrupt-Flag auf 0 initialisieren *)
   ml8rt_set_error_handler(@error_handler);      (* Error-Handler definieren *)
   taskno := parameter.tdt.task * 65536;         (* Parameter des MDD setzen: *)
   for i:=0 to 15 do                             (* Task-Nummer dieser Task, Prozedur-Nummern *)
     ml8rt_write_par_dword(SLOT,32+(i*4),taskno+4*i); (* der Prozeduren int_proc_0 bis int_proc_15 *)
   ml8rt_call_proc(SLOT,2);                     (* User-Init des MDD aufrufen *)
   ml8rt_exit;
end;

(* --- channel_init --- *)
(* liest Informationen ueber installierte MDDs *)

procedure channel_init ;
var
   date1: longint;
begin
   ml8rt_entry;

   (* CPS-Struktur fr LED initialisieren *)

   led.usDevice            := DEVICE_LED;
   led.usIndexFirst        := 0;
   led.usIndexLast         := 0;
   led.usReadMode          := IO_MODE_DIRECT;
   parameter.handle_led_0  := mdd8_open_channel (SLOT, sizeof(led), led);
   mdd8_write_channel_byte (parameter.handle_led_0 ,1);

   led.usDevice            := DEVICE_LED;
   led.usIndexFirst        := 0;
   led.usIndexLast         := 1;
   led.usReadMode          := IO_MODE_DIRECT;
   parameter.handle_led_1  := mdd8_open_channel (SLOT, sizeof(led), led);
   mdd8_write_channel_byte (parameter.handle_led_1 , 3);

   (* CPS-Struktur fr dig. Eingnge initialisieren *)

   din.usDevice            := DEVICE_DIN;
   din.usIndexFirst        := 0;
   din.usIndexLast         := 11;
   din.usReadMode          := IO_MODE_DIRECT;
   parameter.handle_din_2  := mdd8_open_channel (SLOT, sizeof(din), din);

   mdd8_write_channel_word (parameter.handle_din_2 ,$55);
   date1 := mdd8_read_channel_word (parameter.handle_din_2);
   if (date1 <> $55) then
     begin
     (* Fehlerbehandlung *)
     end;

   (* Anwahl Interrupt zur Basiskarte *)

   intr_ctrl.usDevice         := DEVICE_CTRL;
   intr_ctrl.usIndexFirst     := 0;
   intr_ctrl.usIndexLast      := 0;
   intr_ctrl.usReadMode       := IO_MODE_DIRECT;
   intr_ctrl.usWriteMode      := IO_MODE_DIRECT;
   parameter.handle_ctrl_0    := mdd8_open_channel (SLOT, sizeof(intr_ctrl), intr_ctrl);

   mdd8_write_channel_byte (parameter.handle_ctrl_0 ,_MC163_IRQ_D+_MC163_IRQ_POS_EDGE);

   (* Maskieren/Demaskieren der Interrupt-Eingnge *)

   intr_ctrl.usDevice         := DEVICE_CTRL;
   intr_ctrl.usFlags          := _CP_EXCLUSIVE;
   intr_ctrl.usIndexFirst     := 1;
   intr_ctrl.usIndexLast      := 1;
   intr_ctrl.usReadMode       := IO_MODE_DIRECT;
   parameter.handle_ctrl_1  := mdd8_open_channel (SLOT, sizeof(intr_ctrl), intr_ctrl);

   (* Lschen eines Pending-Interrupts auf dem Modul *)

   intr_ctrl.usDevice         := DEVICE_CTRL;
   intr_ctrl.usFlags          := _CP_EXCLUSIVE;
   intr_ctrl.usIndexFirst     := 5;
   intr_ctrl.usIndexLast      := 5;
   intr_ctrl.usReadMode       := IO_MODE_DIRECT;
   parameter.handle_ctrl_5    := mdd8_open_channel (SLOT, sizeof(intr_ctrl), intr_ctrl);

   (* Lschen eines Pending-Interrupts auf dem Modul *)

   mdd8_write_channel_byte (parameter.handle_ctrl_5 , 0);

   (* Interrupt INT-0, INT-4, INT-5, INT-6 und INT-7 demaskieren,
      zustzlich soll bei INT-0 und INT-5 die negative Flanke Interrupt auslsen,
      sonst die positive Flanke *)

   mdd8_write_channel_dword (parameter.handle_ctrl_1, _MC163_DEMASK_INT_0+
                                                      _MC163_DEMASK_INT_4+
                                                      _MC163_DEMASK_INT_5+
                                                      _MC163_DEMASK_INT_6+
                                                      _MC163_DEMASK_INT_7+
                                                      _MC163_INT_0_NEG_EDGE+
                                                      _MC163_INT_5_NEG_EDGE);

   (* Kanal fr Steuerkommandos an Zhler initialisieren *)

   intr_ctrl.usDevice         := DEVICE_CTRL;
   intr_ctrl.usIndexFirst     := 4;
   intr_ctrl.usIndexLast      := 4;
   intr_ctrl.usReadMode       := IO_MODE_DIRECT;
   parameter.handle_ctrl_4    := mdd8_open_channel (SLOT, sizeof(intr_ctrl), intr_ctrl);


   (* Struktur fr 16-Bit Aufwrtszhler initialisieren *)

   configuration.usDevice        := DEVICE_COUNTER;
   configuration.usIndexFirst    := 0;
   configuration.usIndexLast     := 0;
   configuration.usMode          := _MC163_COUNTER_UP;
   configuration.usCounterInput  := _MC163_DIN_4_5_CNT_0;
   configuration.usCounterOutput := _MC163_DOUT_0_CNT_0;
   configuration.usCommandInput  := _MC163_START_DIN_0+
                                    _MC163_STOP_DIN_1+
                                    _MC163_STOP_UFL_CNT_1+
                                    _MC163_LOAD_DIN_0+
                                    _MC163_FREEZE_DIN_1+
                                    _MC163_RESET_DIN_0;
   configuration.usInterrupt     := _MC163_INT_CNT_0_OVL+
                                    _MC163_INT_CNT_0_UFL+
                                    _MC163_INT_CNT_0_END+
                                    _MC163_INT_CNT_0_INVALID;
   configuration.usTime          := _MC163_1_MHZ;
   configuration.usMultiple      := 0;
   configuration.usFlags         := 0;
   configuration.usReadMode      := IO_MODE_DIRECT;
   configuration.usWriteMode     := IO_MODE_DIRECT;
   parameter.handle_count_0      := mdd8_open_channel (SLOT, sizeof(configuration), configuration);

   mdd8_write_channel_word (parameter.handle_count_0, $FF00);

   (* Struktur fr 16-Bit Abwrtszhler initialisieren *)

   configuration.usDevice        := DEVICE_COUNTER;
   configuration.usIndexFirst    := 1;
   configuration.usIndexLast     := 1;
   configuration.usMode          := _MC163_COUNTER_DN;
   configuration.usCounterInput  := _MC163_DIN_6_CNT_1;
   configuration.usCounterOutput := _MC163_DOUT_1_CNT_1;
   configuration.usCommandInput  := _MC163_START_DIN_1+
                                    _MC163_STOP_DIN_2+
                                    _MC163_LOAD_DIN_1+
                                    _MC163_FREEZE_DIN_2+
                                    _MC163_RESET_DIN_1;
   configuration.usInterrupt     := _MC163_INT_CNT_1_OVL+
                                    _MC163_INT_CNT_1_UFL+
                                    _MC163_INT_CNT_1_END;
   configuration.usTime          := _MC163_1_MHZ;
   configuration.usMultiple      := 0;
   configuration.usReadMode      := IO_MODE_DIRECT;
   configuration.usWriteMode     := IO_MODE_DIRECT;

   parameter.handle_count_1      := mdd8_open_channel (SLOT, sizeof(configuration), configuration);

   mdd8_write_channel_word (parameter.handle_count_1,$0100);

   (* Struktur fr Auf-/Abwrtszhler initialisieren *)

   configuration.usDevice        := DEVICE_COUNTER;
   configuration.usIndexFirst    := 2;
   configuration.usIndexLast     := 2;
   configuration.usMode          := _MC163_COUNTER_UP_DN_B;
   configuration.usCounterInput  := _MC163_DIN_4_CNT_2;
   configuration.usCounterOutput := _MC163_DOUT_2_CNT_2;
   configuration.usCommandInput  := _MC163_START_DIN_2+
                                    _MC163_STOP_DIN_3+
                                    _MC163_LOAD_DIN_2+
                                    _MC163_FREEZE_DIN_3+
                                    _MC163_RESET_DIN_2;
   configuration.usInterrupt     := _MC163_INT_CNT_2_OVL+
                                    _MC163_INT_CNT_2_UFL+
                                    _MC163_INT_CNT_2_END;
   configuration.usTime          := _MC163_1_MHZ;
   configuration.usMultiple      := 0;
   configuration.usReadMode      := IO_MODE_DIRECT;
   configuration.usWriteMode     := IO_MODE_DIRECT;

   parameter.handle_count_2 := mdd8_open_channel (SLOT, sizeof(configuration), configuration);

   mdd8_write_channel_word (parameter.handle_count_2,$FF00);

   (* Counter 0 bis 2 laden und starten *)

   command[1] := _MC163_CMD_START_COUNTER+
                 _MC163_CMD_LOAD_COUNTER+
                 _MC163_COUNTER_0;
   command[2] := _MC163_CMD_START_COUNTER+
                 _MC163_CMD_LOAD_COUNTER+
                 _MC163_COUNTER_1;
   command[3] := _MC163_CMD_START_COUNTER+
                 _MC163_CMD_LOAD_COUNTER+
                 _MC163_COUNTER_2;
   mdd8_write_channel_block (parameter.handle_ctrl_4, 3, command);
   ml8rt_unmask_int(IRQ_SLAVE + _MC163_IRQ_D);

  (* Pending Interrupts auf dem Modul lschen *)

  mdd8_write_channel_byte (parameter.handle_ctrl_5 , 0);
  ml8rt_exit;
end;

(* --- PDT initialisieren --- *)

(* PREPARE                          *)

begin

	pdt.pdt_head.ucType          := 1;                   (* set PDT-type                     *)
	pdt.pdt_head.ucSize          := sizeof(ML8_PDT_HEAD);(* length of PDT-header             *)
	pdt.pdt_head.usGlobalProc    := 21;                  (* number of procedures             *)
	pdt.pdt_head.usProgNo        := PROGRAM_NUMBER;      (* program-number                   *)
	pdt.pdt_head.cVersion        := VERSION;             (* program-version                  *)
	pdt.pdt_head.cRevision       := REVISION;            (* program-revision                 *)
	pdt.pdt_head.ucCPU           := _486DX;              (* CPU-type                         *)
	pdt.pdt_head.ucCoProc        := _NOCOPROZ;           (* Co-Prozessor-type                *)
	pdt.pdt_head.ucLanguage      := _TP70;                (* program-language = PASCAL        *)
	pdt.pdt_head.ucProgType      := _USER_PRG;           (* program-type: user-program       *)
	pdt.pdt_head.usFlags         := _NI_TASK + _PDT_INFO_ENABLE + _LOCAL_DATA
                                        + _LOCAL_PARAMETER + _FIXED_DATASIZE;
	pdt.pdt_head.usInt           := 0;                   (* interrupt-number                 *)
	pdt.pdt_head.ulDataAdr       := 0;                   (* address of data-range            *)
	pdt.pdt_head.ulDataSize      := 0;                   (* size of data-range               *)
	pdt.pdt_head.ulDataSizeMin   := 0;                   (* min. size of data-range          *)
	pdt.pdt_head.ulDataSizeMax   := 0;                   (* max. size of data-range          *)
													                (* start address of parameter-range *)
	ml8rt_phys_adr(@parameter,pdt.pdt_head.ulGlobalParAdr);
        pdt.pdt_head.ulGlobalParAdr  := pdt.pdt_head.ulGlobalParAdr + sizeof(TDT_TYPE);
													                (* number of parameter              *)
	pdt.pdt_head.usGlobalParSize := sizeof(parameter) - sizeof(TDT_TYPE);
	pdt.pdt_head.ulHyperAdr      := 0;                   (* address of hypertext-range       *)
	pdt.main_proc                := @main_proc;           (* address of main procedure        *)
	pdt.auto_init                := @auto_init;           (* address of auto_init procedure   *)
	pdt.user_proc                := @channel_init;        (* address of channel_init procedure   *)
        pdt.read_counter             := @read_counter;        (* address of counter read procedure *)
        pdt.read_counter_status      := @read_counter_status; (* address of counter status read procedure *)
        pdt.int_proc_0               := @int_proc_0;          (* addresses of the 16 ISR procedures *)
	pdt.int_proc_1               := @int_proc_1;
	pdt.int_proc_2               := @int_proc_2;
	pdt.int_proc_3               := @int_proc_3;
        pdt.int_proc_4               := @int_proc_4;
	pdt.int_proc_5               := @int_proc_5;
	pdt.int_proc_6               := @int_proc_6;
	pdt.int_proc_7               := @int_proc_7;
        pdt.int_proc_8               := @int_proc_8;
	pdt.int_proc_9               := @int_proc_9;
	pdt.int_proc_10              := @int_proc_10;
	pdt.int_proc_11              := @int_proc_11;
        pdt.int_proc_12              := @int_proc_12;
	pdt.int_proc_13              := @int_proc_13;
	pdt.int_proc_14              := @int_proc_14;
	pdt.int_proc_15              := @int_proc_15;
        ml8rt_set_pdt_adr(pdt);     (* return address of PDT to OS      *)
end.

